SystemOrganization addCategory: #'OpenDBX-Core-Structure'!
SystemOrganization addCategory: #'OpenDBX-Core-API'!
SystemOrganization addCategory: #'OpenDBX-Core-Tests'!
SystemOrganization addCategory: #'OpenDBX-Core-Description'!
SystemOrganization addCategory: #'OpenDBX-Core-Benchmark'!

!False methodsFor: '*OpenDBX-Core' stamp: 'EL 8/14/2008 09:18'!
asDbxString
	^'false'! !

ExternalStructure subclass: #DBXTimeSpec
	instanceVariableNames: 'seconds nseconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXTimeSpec class methodsFor: 'field definition' stamp: 'MMP 9/16/2008 01:51'!
fields
	^#(
		(seconds	     'long')
		(nseconds	'long'))! !

!DBXTimeSpec class methodsFor: 'field definition' stamp: 'MMP 9/29/2008 22:26'!
initialize
	super initialize.
	self defineFields! !

!DBXTimeSpec class methodsFor: 'field definition' stamp: 'EL 3/30/2008 15:36'!
seconds: seconds
	^(self new)
		seconds: seconds;
		nseconds: 0;
		yourself.! !

!DBXTimeSpec class methodsFor: 'field definition' stamp: 'MMP 1/21/2009 00:23'!
seconds: seconds microseconds: microseconds
	^(self new)
		seconds: seconds;
		nseconds: microseconds;
		yourself.! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'MMP 2/22/2009 20:25'!
nseconds
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'MMP 2/22/2009 20:25'!
nseconds: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'MMP 2/22/2009 20:25'!
seconds
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'MMP 2/22/2009 20:25'!
seconds: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

!String class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:11'!
fromDbxString: aString
	^aString! !

!String methodsFor: '*OpenDBX-Core' stamp: 'MMP 2/4/2009 23:46'!
asDbxString
	^self class new writeStream
		nextPut: $';
		nextPutAll: self;
		nextPut: $';
		contents! !

Notification subclass: #DBXNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!Time class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:36'!
fromDbxString: aString 
	^ self readDbxFrom: aString readStream! !

!Time class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:11'!
readDbxFrom: aStream
	| hour minute second |

	hour := (aStream upTo: $:) asInteger.
	minute := (aStream upTo: $:) asInteger.
	second := (aStream upToEnd) asInteger.

	^self hour: hour  
		minute: minute 
		second:  second! !

!Time methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:24'!
asDbxString
	| stream |
	stream := String new writeStream.
	self printDbxOn: stream.	
	^ stream contents asDbxString! !

!Time methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:24'!
printDbxOn: aStream
	aStream
		nextPutAll: (self hour asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self minutes asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self seconds asString padded: #left to: 2 with: $0).
! !

!TimeStamp methodsFor: '*OpenDBX-Core' stamp: 'MMP 10/13/2008 19:14'!
yyyymmddhhmmss
"It returns a String with tha timestamp in yyyy-mm-dd hh:mm:ss format.
Example: 

(TimeStamp 
			year: 2008 
			month: 1 
			day: 20 
			hour: 10 
			minute: 20 
			second: 30) yyyymmddhhmmss.

shows: '2008-01-20 10:20:30'  "

	| stream |
	stream := String new writeStream.
	self printDbxOn: stream.
	^ stream contents! !

!DateAndTime class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 11:29'!
fromDbxString: aString 
	^self readDbxFrom: aString readStream! !

!DateAndTime class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 11:30'!
readDbxFrom: aStream
	| year month day hour minute second |

	year := (aStream upTo: $-) asInteger.
	month := (aStream upTo: $-) asInteger.
	day := (aStream upTo: Character space) asInteger.
	hour := (aStream upTo: $:) asInteger.
	minute := (aStream upTo: $:) asInteger.
	second := (aStream upToEnd) asInteger.
	
	^ self
		year: year
		month: month
		day: day
		hour: hour
		minute: minute
		second: second.! !

!DateAndTime methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:29'!
asDbxString
	| stream |
	stream := String new writeStream.
	self printDbxOn: stream.
	^ stream contents asDbxString! !

!DateAndTime methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:30'!
printDbxOn: aStream
	aStream
		nextPutAll: self year asString;
		nextPut: $-;
		nextPutAll: (self monthIndex asString padded: #left to: 2 with: $0);
		nextPut: $-;
		nextPutAll: (self dayOfMonth asString padded: #left to: 2 with: $0);
		nextPut: Character space;	
		nextPutAll: (self hour asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self minutes asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self seconds asString padded: #left to: 2 with: $0).
! !

TestCase subclass: #DBXBaseTest
	instanceVariableNames: 'facility connection'
	classVariableNames: 'Facility'
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXBaseTest class methodsFor: 'accessing' stamp: 'MMP 8/5/2008 01:19'!
facility
	^ Facility! !

!DBXBaseTest class methodsFor: 'accessing' stamp: 'MMP 8/5/2008 01:19'!
facility: anObject
	Facility := anObject! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:59'!
doConnect
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.	
	conn connect.
	^conn! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:55'!
doConnectAndOpen
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.
	conn connect.
	conn open.
	^ conn! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'MMP 5/22/2008 00:15'!
doDisconnect: aConnection 
	aConnection disconnect.! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 12/1/2008 00:09'!
dropScript: aConnection 
	"Here we catch the errors because the first time the tests are run, if you didn't create the tables by hand before, you will have an error here (because de table doesn't exist') and it won't continue to the create statements."
	
	self facility scriptsDrops 
		do: [:script | [ aConnection execute: script ] 
			on: DBXError
			do: [ :e |  Transcript show: e.  ].]
	! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:44'!
facility
	^ facility! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:44'!
facility: anObject
	facility := anObject! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:44'!
platform
	^ facility platform! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'EL 8/19/2008 17:53'!
platformCall: aSelector
	self platformCall: aSelector withArguments: #()! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'EL 8/19/2008 13:35'!
platformCall: aSelector with: anObject
	self platformCall: aSelector withArguments: (Array with: anObject)! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'EL 8/19/2008 17:52'!
platformCall: aSelector withArguments: anArray
	| platformSelector |
	
	platformSelector := ('platform', 
		self facility platform backend capitalized, 
		aSelector capitalized) 
			asSymbol.
	(self class allSelectors includes: platformSelector)
		ifTrue: [ self perform: platformSelector withArguments: anArray ]! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 9/17/2008 23:44'!
runDDLSetUpScript: aConnection 
	"The database structure is the same for all tests and most of them will
	need to have the structure generated. So, this method do exactly that,"
	"Here we catch the errors because the first time the tests are run, if
	you didn't create the tables by hand before, you will have an error
	here (because de table doesn't exist') and it won't continue to the create
	statements."
	self dropScript: aConnection.
	"Now I create all tables, fks, indexes, and so on."
	self facility scriptsDDL
		do: [:script | aConnection execute: script]! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 9/17/2008 23:18'!
runDDLTearDownScript: aConnection
	"Till now, nothing is done here"! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 7/9/2008 02:20'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "
	self subclassResponsibility! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 3/10/2009 03:23'!
setUp
	"The setUp of this DBXBaseTest lets the database clear to tests. It runs the
	DDL and the common DML script for testing. Then each subclass should
	inserter, delete or whatever it need"
	super setUp.
	"this should be done from outside"
	facility := self class facility.
	connection := self doConnectAndOpen.
	self runDDLSetUpScript: connection.
	self runDMLSetUpScript: connection.
	connection disconnect.
! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'EL 7/1/2008 15:19'!
settings
	^ facility connectionSettings! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 3/10/2009 03:24'!
tearDown
	"This method run a DDL script to free results and close the connection used in the setUp and in here"
	super tearDown.
	connection := self doConnectAndOpen.
	self runDDLTearDownScript: connection.
	self doDisconnect: connection.
	connection := nil.! !

DBXBaseTest subclass: #DBXCompleteExamplesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXCompleteExamplesTest methodsFor: 'as yet unclassified' stamp: 'HMC 10/24/2008 19:03'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	
	aConnection execute: 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (1, ''Mariano Squeak'', 23) '.
	aConnection execute:'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (2, ''Hernan Squeak'', 23) '.! !

!DBXCompleteExamplesTest methodsFor: 'as yet unclassified' stamp: 'HMC 10/24/2008 19:03'!
testACompleteExample
	| conn connectionSettings result result2 |
	connectionSettings := self facility connectionSettings deepCopy.
	conn := DBXConnection platform: self platform deepCopy settings: connectionSettings.
	conn connect.
	conn open.
	result := conn execute: 'select * from materia'.
	DBXTranscript show: result.
	conn execute: 'INSERT INTO materia(codigo, nombre, observaciones, id_alumno) VALUES (59, ''TADP'', ''Tecnicas Av'', 1) '.
	conn execute: 'INSERT INTO materia(codigo, nombre, observaciones, id_alumno) VALUES (60, ''APIT'', ''ARQUITECTURA DE PROYECTOS DE IT'', 2) '.
	result := conn execute: 'select * from materia'.
	DBXTranscript show: result.
	result := conn execute: 'delete from materia where nombre = ''TADP'''.
	DBXTranscript show: result.
	result2 := conn execute: 'select * from materia'.
	DBXTranscript show: result2.
	result := conn execute: 'update materia set observaciones = ''something'' where codigo = 60'.
	DBXTranscript show: result.
	result2 := conn execute: 'select * from materia'.
	DBXTranscript show: result2.
	conn close.
	conn disconnect! !

DBXBaseTest subclass: #DBXConnectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXConnectionTest methodsFor: 'helpers' stamp: 'MMP 7/8/2008 20:56'!
doConnectAndDisconnect
	| conn |
	conn := self doConnectAndOpen.
	conn disconnect.
	^conn! !

!DBXConnectionTest methodsFor: 'running' stamp: 'MMP 6/17/2008 22:56'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 1/9/2009 00:32'!
testCloseIncorrect
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.

	"I have not do a open so this should rise an error"
	self 
		should: [ conn close ]
		raise: DBXError.
	"The same if i Try to do a query"
	self 
		should: [ conn execute: 'SELECT * from alumno where id = 1' ]
		raise: DBXError.
	conn := self doConnectAndOpen.
	"The first time should work well"
	conn close.
	"now, as I have already done a close, this shoud rise an error"
	self 
		should: [ conn close ]
		raise: DBXError! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'EL 7/1/2008 15:24'!
testCloseWithoutOpen
	| conn |
	conn := DBXConnection 
				platform: self platform
				settings: self settings.	
	self should: [ conn close ] raise: DBXError.! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 7/8/2008 20:55'!
testConnectAndOpen
	| conn |
	conn := self doConnectAndOpen.
	conn disconnect.
	^ conn! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 7/9/2008 19:12'!
testConnectIncorrect
	| conn |
	conn := self doConnectAndOpen.

	"As I have already done a connect: it should raise an error"
	self 
		should: [ conn connect ]
		raise: DBXError! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 7/9/2008 02:39'!
testConnectOpenCloseOpen
	| conn  |
	conn := self doConnectAndOpen.
	self assert: conn isOpen.
	conn close.
	self assert: conn isOpen not.
	conn open.
	self assert: conn isOpen.
	conn close.
	conn disconnect.
	! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 2/22/2009 20:45'!
testDisconnectIncorrect
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.

	"I   have not do a connect first so this shouldnt rise an error"
	
	self 
		shouldnt: [ conn disconnect ]
		raise: DBXError.
	conn := self doConnectAndOpen.
	"The first time should work well"
	conn disconnect.
	"now, as I have already done a disconnect, this shoudnt rise an error"
	self 
		shouldnt: [ conn disconnect ]
		raise: DBXError! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 12/22/2008 20:43'!
testDisconnectWithoutConnect
	| conn | 
	conn := DBXConnection 
				platform: self platform
				settings: self settings.	
		
	self shouldnt: [ conn disconnect ] raise: DBXError.
	! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 2/4/2009 23:42'!
testGCDisconnection
	"I have to call garbageCollect because maybe there are previous
	connections that are inconsistence or maybe they just have references
	and because of this the GC doesn't clean them. We assume there aren't
	created new connections at the same time of running the test from
	elsewhere"
	| connectionInstancesSizeBeforeTest weakRegistrySizeBeforeTest |
	1
		to: 3
		do: [:i | Smalltalk garbageCollect].
	connectionInstancesSizeBeforeTest := DBXConnection allInstances size.
	weakRegistrySizeBeforeTest := (WeakRegistry default keys
				select: [:each | each class = DBXConnection]) size.
	self doConnectAndOpen.
	1
		to: 3
		do: [:i | Smalltalk garbageCollect].
	self assert: DBXConnection allInstances size = connectionInstancesSizeBeforeTest.
	self assert: (WeakRegistry default keys
			select: [:each | each class = DBXConnection]) notEmpty! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 6/17/2008 22:12'!
testManualAndGCDisconnection

	"I have to call garbageCollect because maybe there are previous connections that are inconsistence or maybe they 	just have references and because of this the GC doesn't clean them. We assume there aren't created new connections 	at the same time of running the test from elsewhere "
	
	| connectionInstancesSizeBeforeTest |
	1 to: 3 do: [ :i | Smalltalk garbageCollect ].
	connectionInstancesSizeBeforeTest := DBXConnection allInstances size.
		
	self doConnectAndDisconnect.
	1 to: 3 do: [ :i | Smalltalk garbageCollect ].
	self assert: DBXConnection allInstances size = connectionInstancesSizeBeforeTest.! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 7/9/2008 02:33'!
testManualDisconnection
	| conn conn2 |
	conn := self doConnect.
	conn disconnect.
	conn2 := self doConnectAndOpen.
	conn2 close.
	conn2 disconnect! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 9/14/2008 23:58'!
testMultipleConnectionsPerThread
	| conn |
	conn := self doConnectAndOpen.
	conn := self doConnectAndOpen.
	conn := self doConnectAndOpen.
	conn := self doConnectAndOpen.
	conn := self doConnectAndOpen.
! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 7/9/2008 19:12'!
testOpenIncorrect
	| conn |
	conn := self doConnectAndOpen.

	"as I have already open the connection this should rise a DBXError"
	self 
		should: [ conn open ]
		raise: DBXError.
	self 
		should: [ conn open ]
		raise: DBXError.
	self 
		should: [ conn open ]
		raise: DBXError! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 8/4/2008 23:57'!
testReOpen
	| conn connectionSettings |
	conn := self doConnectAndOpen.
	connectionSettings := self settings.
	"Actually I should test this with a different database, username and password. "
	conn reOpen: connectionSettings.
	conn close.
	conn disconnect.
	! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 7/8/2008 20:57'!
testShutDownAndStartUp
	| conn  |
	conn := self doConnectAndOpen.
	self assert: conn isOpen.
	conn shutDown.
	self assert: conn isOpen not.
	conn startUp.
	self assert: conn isOpen not.
! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 7/8/2008 20:59'!
testShutDownDisconnection
	| conn  |
	conn := self doConnectAndOpen.
	conn shutDown.
	self assert: conn isOpen not
! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 4/25/2008 02:01'!
testShutDownManualDisconnection
	| conn  |
	conn := self doConnectAndDisconnect.
	self assert: conn isOpen not.
	conn shutDown.
	self assert: conn isOpen not
! !

DBXBaseTest subclass: #DBXDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXDescriptionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/18/2008 19:17'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXDescriptionTest methodsFor: 'as yet unclassified' stamp: 'HMC 10/24/2008 19:06'!
testGetColumnDescription
	| conn select result aRow |
	select := 'SELECT * FROM materia'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	self
		should: [result description columnDescriptionAt: 0]
		raise: Error.
	self
		should: [result description columnDescriptionAt: 7]
		raise: Error.
	self
		shouldnt: [result description columnDescriptionAt: 1]
		raise: Error.
	self
		shouldnt: [result description columnDescriptionAt: 2]
		raise: Error.
	self assert: ((result description columnDescriptionAt: 1) name sameAs: 'codigo').
	aRow := result nextRow.
	self assert: aRow isNil.
	select := 'SELECT codigo FROM materia'.
	result := conn execute: select.
	self
		should: [result description columnDescriptionAt: 2]
		raise: Error.
	self
		shouldnt: [result description columnDescriptionAt: 1]
		raise: Error.
	self assert: ((result description columnDescriptionAt: 1) name sameAs: 'codigo').
	aRow := result nextRow.
	self assert: aRow isNil.
	conn close.
	conn disconnect! !

!DBXDescriptionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/18/2008 19:23'!
testGetColumnDescriptionWithName
	| conn select result aRow |
	conn := self doConnectAndOpen.
	select := 'SELECT codigo FROM materia'.
	result := conn execute: select.
	self
		should: [result columnDescriptionWithName: 'noexist']
		raise: DBXError.
	self
		should: [result columnDescriptionWithName: 'nombre']
		raise: DBXError.
	self
		shouldnt: [result columnDescriptionWithName: 'codigo']
		raise: DBXError.
	aRow := result nextRow.
	self assert: aRow isNil.
	conn close.
	conn disconnect! !

!DBXDescriptionTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/24/2008 20:57'!
testGetColumnDescriptionWithNameAlias
	| conn select result aRow |
	conn := self doConnectAndOpen.
	select := 'SELECT codigo as uncodigo FROM materia'.
	result := conn execute: select.
	self
		should: [result columnDescriptionWithName: 'noexist']
		raise: DBXError.
	self
		should: [result columnDescriptionWithName: 'nombre']
		raise: DBXError.
	self
		should: [result columnDescriptionWithName: 'codigo']
		raise: DBXError.
	self
		shouldnt: [result columnDescriptionWithName: 'uncodigo']
		raise: DBXError.
	
	aRow := result nextRow.
	self assert: aRow isNil.
	conn close.
	conn disconnect! !

DBXBaseTest subclass: #DBXOptionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/24/2008 16:49'!
executeEncryptionWithOption: anEncrytionValue 
	| conn result |
	conn := self doConnect.
	result := conn enableEncryption: anEncrytionValue.
	conn open.
	result
		ifTrue: [ Transcript show: 'Encryption supported' ; cr.
				self shouldnt: [ conn execute: 'select codigo from materia' ] raise: Error .
				].
	result
		ifFalse: [ Transcript show: 'Encryption not supported' ; cr.
				self shouldnt: [ conn execute: 'select codigo from materia' ] raise: Error .
				].	
	conn close.
	conn disconnect.
	conn := nil! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/24/2008 22:50'!
insertRows:  aNumberOfRows
	| conn |

	Transcript show: 'Inserting ', aNumberOfRows asString, ' rows'; cr.
	conn := self doConnectAndOpen.
	conn startTransaction.
	1
		to: aNumberOfRows
		do: [:i | conn
				execute: ('INSERT INTO alumno (id, nombre_apellido, edad) VALUES ( {1} ,''Esteban
	Squeak'', 42)' format: (OrderedCollection new add: i asInteger asDbxString;
							 yourself))].
	conn commit.
	conn disconnect.
	Transcript show: aNumberOfRows asString, ' rows were inserted'; cr.	! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/9/2008 02:16'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 1/31/2009 20:52'!
selectRowsWithPageSize: aPageSize onConnection: aConnection 
	| resultQuery timeBefore timeAfter querySettings |
	
	querySettings := DBXQuerySettings pageSize: aPageSize timeout: DBXQuerySettings defaultTimeout.
	
	timeBefore := Time current asSeconds.
	Transcript show: 'PagedResults supported. Test with page size ' , aPageSize asString;
		 cr.
	
	resultQuery := aConnection execute: 'select * from alumno' querySettings: querySettings.
		
		
	"self
		shouldnt: [resultQuery := aConnection execute: 'select * from alumno' querySettings: querySettings]
		raise: Error."
		
		
	resultQuery
		rowsDo: [:row | row].
	timeAfter := Time current asSeconds.
	Transcript show: 'Time consumed: ' , (timeAfter - timeBefore) asString, ' seconds';
		 cr! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/18/2008 01:57'!
testCompression
	| conn result |
	conn := self doConnect.
	result := conn enableCompression.
	conn open.
	result ifTrue: 
		[ Transcript
			show: 'Compression supported';
			cr.
		self 
			shouldnt: [ conn execute: 'select * from alumno' ]
			raise: Error ].
	result ifFalse: 
		[ Transcript
			show: 'Compression doesnt supported';
			cr.
		self 
			shouldnt: [ conn execute: 'select * from alumno' ]
			raise: Error ].
	conn close.
	conn disconnect.
	conn := nil! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/24/2008 16:53'!
testEncryption
	"self executeEncryptionWithOption: DBXEncryptionValues never.
	self executeEncryptionWithOption: DBXEncryptionValues try.
"
	self executeEncryptionWithOption: DBXEncryptionValues always.
	"self executeEncryptionWithOption: '-1'.
	self
		should: [self executeEncryptionWithOption: '-1']
		raise: DBXError. 
	
self executeEncryptionWithOption: '3'.

	self should: [self executeEncryptionWithOption: '3']
		raise: DBXError Unmatched comment quote ->"! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/18/2008 01:57'!
testGetOption
	| conn isSupported |
	conn := self doConnect.
	isSupported := conn isOptionSupportedByPlattform: DBXSpecialOptions multipleStatements.
	conn open.
	conn close.
	conn disconnect.
	conn := nil! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 1/5/2009 19:54'!
testMultipleStatments
	| conn result resultSet resultSet2 |
	conn := self doConnect.
	result := conn enableMultipleStatements.
	conn open.
	
	conn execute: 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (5, ''Esteban Squeak'', 42) '.
	conn execute: 'INSERT INTO materia(codigo, nombre, observaciones, id_alumno) VALUES (59, ''TADP'', ''Tecnicas Av'', 5) '.
	
	result ifTrue: 
		[ Transcript
			show: 'MultipleStatments supported';
			cr.
		self 
			shouldnt: 
				[ resultSet := conn execute: 'select id from alumno; select codigo, nombre from materia' ]
			raise: DBXError.
		self assert: resultSet columnCount = 1.
		resultSet nextRow.
		self assert: resultSet columnCount = 1.
		resultSet nextRow.
		self assert: resultSet columnCount = 2.
		self assert: (resultSet nextRow) isNil.
		self assert: resultSet columnCount = 2. ].
	result ifFalse: 
		[ Transcript
			show: 'MultipleStatments doesnt supported';
			cr.
			
		"In ODBC case, as you cannot know trought ODBC if the current backends supports or not certain option, this features is disable. But, if 		you are using a backend that support its, the multistatement will work ok. Suppose you are using ODBC with a PostgeSQL server. ODBC 		doesn't	support this feature, but PostgreSQL will. So, If you actually use multistatement, it will work."
		(self platform class = DBXOdbcPlatform) ifFalse: [
			self 
				should: [ resultSet2 := conn execute: 'select * from alumno; select * from materia'.
				DBXTranscript show: resultSet2. ]
				raise: DBXError ].
		].
	conn close.
	conn disconnect.
	conn := nil! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/24/2008 23:55'!
testPagedResults
	| conn result rows |
	rows := 5000.
	self insertRows: rows.
	conn := self doConnect.
	result := conn enablePagedResults.
	conn open.
	result
		ifTrue: [self selectRowsWithPageSize: 0 onConnection: conn.
			self selectRowsWithPageSize: 1 onConnection: conn.
			self selectRowsWithPageSize: rows onConnection: conn.
			self selectRowsWithPageSize: rows / 10 onConnection: conn.
			self selectRowsWithPageSize: rows / 100 onConnection: conn].
	conn close.
	conn disconnect.
	conn := nil! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/18/2008 17:23'!
testScpeialModes
	| conn result update |
	self platform class = DBXMySQLPlatform ifFalse: [ ^ nil ].
	conn := self doConnect.
	result := conn enableSpecialModes: 'ANSI,TRADITIONAL'.
	conn open.
	conn execute: 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (1, ''Mariano Squeak'', 23) '.
	result ifTrue: 
		[ Transcript
			show: 'ScpecialMySQLModes supported';
			cr.
		update := 'update alumno set edad = ''should be numeric'' '.
		self 
			should: [ conn execute: update ]
			raise: DBXError ].
	result ifFalse: 
		[ Transcript
			show: 'ScpecialMySQLModes supported';
			cr.
		update := 'update alumno set edad = ''should be numeric'' '.
		self 
			shouldnt: [ conn execute: update ]
			raise: DBXError ].
	conn close.
	conn disconnect.
	conn := self doConnectAndOpen.
	conn execute: 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (2, ''Mariano Squeak'', 23) '.
	update := 'update alumno set edad = ''should be numeric'' '.
		self 
			shouldnt: [ conn execute: update ]
			raise: DBXError.
	conn := nil. 
! !

DBXBaseTest subclass: #DBXQueryBaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXQueryBaseTest methodsFor: 'running' stamp: 'MMP 1/5/2009 20:08'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "
	
	aConnection execute: 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (1, ''Mariano Squeak'', 23) '.
	aConnection execute:'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (2, ''Hernan Squeak'', 23) '.
	aConnection execute: 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (3, ''German Squeak'', 23) '.
	aConnection execute: 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (4, ''Alejandro Squeak'', 30) '.
	aConnection execute: 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (5, ''Esteban Squeak'', 42) '.
	
	aConnection execute: 'INSERT INTO materia(codigo, nombre, observaciones, id_Alumno) VALUES (59, ''TADP'', ''Tecnicas Av'', 1) '.
	aConnection execute: 'INSERT INTO materia(codigo, nombre, observaciones, id_Alumno) VALUES (60, ''APIT'', ''ARQUITECTURA DE PROYECTOS DE IT'', 2) '.
	
	"aConnection execute: 'INSERT INTO curso(id_curso, id_alumno, codigo_materia, fecha_inicio) VALUES (5, 5, 5, null);'."! !

DBXQueryBaseTest subclass: #DBXQueryDDLTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXQueryDDLTest class methodsFor: '*OpenDBX-Core' stamp: 'MMP 8/9/2008 19:27'!
fromDbxString: aString 
	self shouldBeImplemented! !

!DBXQueryDDLTest methodsFor: 'running' stamp: 'MMP 8/9/2008 19:27'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "
	! !

!DBXQueryDDLTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/9/2008 19:46'!
testExecuteDDLScript
	| conn |
	conn := self doConnectAndOpen.
	conn executeDDLScript: 'DROP TABLE curso;
		DROP TABLE materia;
		DROP TABLE alumno'.
		
	"scriptsDDL := self facility scriptsDDL.
	fullScript := String new writeStream.
	scriptsDDL do: [ :script | fullScript nextPutAll: script ]."
	
! !

DBXQueryBaseTest subclass: #DBXQueryDMLTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXQueryDMLTest methodsFor: 'deleteTests' stamp: 'MMP 3/10/2009 01:59'!
testDelete
	| conn delete result |
	conn := self doConnectAndOpen.

	"SQLite implements the command 'DELETE FROM table' without a WHERE clause by dropping and recreating the 	table. (This is much faster than going through and deleting individual elements from the table.) Because of this 	optimization, the deletions in 'DELETE FROM table' are not row changes and will not be counted by the 	sqlite3_changes() or sqlite3_total_changes() functions, regardless of the number of elements that were originally 	in the table. To get an accurate count of the number of rows deleted, use 'DELETE FROM table WHERE 1' instead."


	delete := 'delete from materia WHERE 1=1'.
	result := conn execute: delete.
	self assert: result rowsAffected isZero not.! !

!DBXQueryDMLTest methodsFor: 'deleteTests' stamp: 'MMP 3/10/2009 02:01'!
testDeleteFollowedByAnotherDelete
	| conn aResult anotherResult aDelete anotherDelete |
	conn := self doConnectAndOpen.
	aDelete  := 'delete from materia where codigo = 59'.
	anotherDelete  := 'delete from materia where codigo = 60'.
	aResult := conn execute: aDelete.
	self shouldnt: [ anotherResult := conn execute: anotherDelete ] raise: DBXError.
	self assert: aResult rowsAffected isZero not.
	self assert: anotherResult rowsAffected isZero not.! !

!DBXQueryDMLTest methodsFor: 'deleteTests' stamp: 'MMP 2/3/2009 00:54'!
testDeleteIsClosedAfterExecute
	| conn result delete |
	conn := self doConnectAndOpen.
	delete := 'delete from materia'.
	result := conn execute: delete.! !

!DBXQueryDMLTest methodsFor: 'deleteTests' stamp: 'HMC 8/7/2008 17:07'!
testDeleteWithBadData
	| conn delete |
	conn := self doConnectAndOpen.
	delete := 'delete from alumno where id = should be numeric'.
	self should: [ conn execute: delete  ] raise: DBXError.! !

!DBXQueryDMLTest methodsFor: 'deleteTests' stamp: 'HMC 10/24/2008 19:10'!
testDuplicateDelete
	| conn result delete |
	conn := self doConnectAndOpen.
	delete := 'delete from materia'.
	result := conn execute: delete.
	self shouldnt: [ conn execute: delete ] raise: DBXError.! !

!DBXQueryDMLTest methodsFor: 'insertTests' stamp: 'MMP 12/22/2008 23:58'!
testDuplicateInsert
	| conn result insert |
	
	"SQLite client library has a problem with duplicated inserts. So, we skip that tests for sqlite"
	(self platform class = DBXSqlitePlatform) ifTrue: [^ nil]. 
	
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO materia(codigo, nombre, observaciones, id_alumno) VALUES (55, ''TADP'', ''Nothing'', 1) '.
	result := conn execute: insert.
	self should: [ conn execute: insert ] raise: DBXError.! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'HMC 8/7/2008 17:07'!
testDuplicateUpdate
	| conn result update |
	conn := self doConnectAndOpen.
	update := 'update alumno set edad = ''25'' '.
	result := conn execute: update.
	self shouldnt: [ conn execute: update ] raise: DBXError.! !

!DBXQueryDMLTest methodsFor: 'insertTests' stamp: 'MMP 3/10/2009 02:00'!
testInsert
	| conn result insert |
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO materia(codigo, nombre, observaciones, id_alumno) VALUES (55, ''TADP'', ''Nothing'', 1) '.
	result := conn execute: insert.
	self assert: result rowsAffected isZero not.! !

!DBXQueryDMLTest methodsFor: 'insertTests' stamp: 'MMP 3/10/2009 02:01'!
testInsertFollowedByAnotherInsert
	| conn aResult anotherResult AnInsert anotherInsert |
	conn := self doConnectAndOpen.
	AnInsert := 'INSERT INTO materia(codigo, nombre, observaciones, id_alumno) VALUES (55, ''TADP'', ''Nothing'', 1) '.
	anotherInsert := 'INSERT INTO materia(codigo, nombre, observaciones, id_alumno) VALUES (56,''TADP2'',''Nothing'', 2)'.
	aResult := conn execute: AnInsert.
	self shouldnt: [ anotherResult := conn execute: anotherInsert ] raise: DBXError.
	self assert: aResult rowsAffected isZero not.
	self assert: anotherResult rowsAffected isZero not.! !

!DBXQueryDMLTest methodsFor: 'insertTests' stamp: 'MMP 2/3/2009 00:55'!
testInsertIsClosedAfterExecute
	| conn result insert |
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO materia(codigo, nombre, observaciones, id_alumno) VALUES (55, ''TADP'', ''Nothing'', 1) '.
	result := conn execute: insert.! !

!DBXQueryDMLTest methodsFor: 'insertTests' stamp: 'MMP 9/21/2008 20:07'!
testInsertWithBadData
	| conn insert |
	
	"SQLite does not enforce data type constraints. Any data can be inserted into any column. You can put arbitrary length strings into integer columns, floating point numbers in boolean columns, or dates in character columns. The datatype you assign to a column in the CREATE TABLE command does not restrict what data can be put into that column. Every column is able to hold an arbitrary length string. (There is one exception: Columns of type INTEGER PRIMARY KEY may only hold a 64-bit signed integer. An error will result if you try to put anything other than an integer into an INTEGER PRIMARY KEY column.)
    But SQLite does use the declared type of a column as a hint that you prefer values in that format. So, for example, if a column is of type INTEGER and you try to insert a string into that column, SQLite will attempt to convert the string into an integer. If it can, it inserts the integer instead. If not, it inserts the string. This feature is sometimes call type or column affinity. "
	(self platform class = DBXSqlitePlatform ) ifTrue: [ ^ self ].
	
	
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO materia(codigo, nombre, observaciones) VALUES ("should be numeric", 1, 1) '.
	self should: [ conn execute: insert  ] raise: DBXError.! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'HMC 8/7/2008 17:07'!
testMultipleUpdate
	| conn result update |
	conn := self doConnectAndOpen.
	update := 'update alumno set edad = ''25'' '.
	result := conn execute: update.
	result := conn execute: update.
	result := conn execute: update.
	result := conn execute: update.
	result := conn execute: update.
	result := conn execute: update.
	result := conn execute: update.
! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'MMP 1/21/2009 01:06'!
testTimeout
"	| conn |
	conn := self doConnectAndOpen.
	
	MessageTally time: [
	10000 timesRepeat: [ 
		conn execute: 
			'INSERT INTO tiny_benchmark_insert
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')' ].].
	
	
	self break.
	Transcript show: 'tiempo final: ',
	(MessageTally time: [
	(conn execute: 'SELECT * FROM tiny_benchmark_insert')
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ]  ].
	]) asString.

	self break."! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'MMP 3/10/2009 02:00'!
testUpdate
	| conn result update |
	conn := self doConnectAndOpen.
	update := 'update alumno set edad = ''25'' '.
	result := conn execute: update.
	self assert: result rowsAffected isZero not.! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'MMP 3/10/2009 02:01'!
testUpdateFollowedByAnotherUpdate
	| conn aResult anotherResult anUpdate anotherUpdate |
	conn := self doConnectAndOpen.
	anUpdate := 'update alumno set edad = ''25'' '.
	anotherUpdate := 'update alumno set edad = ''23'' '.
	aResult := conn execute: anUpdate.
	self shouldnt: [ anotherResult := conn execute: anotherUpdate ] raise: DBXError.
	self assert: aResult rowsAffected isZero not.
	self assert: anotherResult rowsAffected isZero not.! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'MMP 2/3/2009 00:55'!
testUpdateIsClosedAfterExecute
	| conn result update |
	conn := self doConnectAndOpen.
	update := 'update alumno set edad = ''25'' '.
	result := conn execute: update.! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'MMP 9/21/2008 20:07'!
testUpdateWithBadData
	| conn update |	
	
	"SQLite does not enforce data type constraints. Any data can be inserted into any column. You can put arbitrary length strings into integer columns, floating point numbers in boolean columns, or dates in character columns. The datatype you assign to a column in the CREATE TABLE command does not restrict what data can be put into that column. Every column is able to hold an arbitrary length string. (There is one exception: Columns of type INTEGER PRIMARY KEY may only hold a 64-bit signed integer. An error will result if you try to put anything other than an integer into an INTEGER PRIMARY KEY column.)
    But SQLite does use the declared type of a column as a hint that you prefer values in that format. So, for example, if a column is of type INTEGER and you try to insert a string into that column, SQLite will attempt to convert the string into an integer. If it can, it inserts the integer instead. If not, it inserts the string. This feature is sometimes call type or column affinity. "
	(self platform class = DBXSqlitePlatform ) ifTrue: [ ^ self ].
	

	conn := self doConnect.
	self flag: #todo.
	"Only for MySQL, I need to enable ansi and traditional mode in order to get an error in this query. We need the tests refactor for special backends"
	(self platform class = DBXMySQLPlatform) ifTrue: [ conn enableSpecialModes: 'ANSI,TRADITIONAL'. ].
	
	
	
	
	conn open.
	update := 'update alumno set edad = ''should be numeric'' '.
	self
		should: [conn execute: update]
		raise: DBXError! !

DBXQueryBaseTest subclass: #DBXQueryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXQueryTest methodsFor: 'tests' stamp: 'test 10/11/2008 13:24'!
testCloseBeforeQuery
	| conn select |
	conn := self doConnectAndOpen.
	conn close.
	select := 'SELECT * FROM materia'.
	self
		should: [conn execute: select]
		raise: DBXError.
	conn disconnect! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/7/2008 17:29'!
testCloseResultsByClosingConnection
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia'.
	result := conn execute: select.
	conn disconnect.
	self deny: result isOpen.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 10/24/2008 19:12'!
testCorrectResult
	| conn select result aRow delete update insert drop |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM curso'.
	result := conn execute: select.
	self
		should: [result class = DBXResultSet].
	aRow := result nextRow.
	self assert: aRow isNil.
	delete := 'delete from curso'.
	result := conn execute: delete.
	self
		should: [result class = DBXResult].
	update := 'update materia set nombre = ''XXX'' '.
	result := conn execute: update.
	self
		should: [result class = DBXResult].
	insert := 'INSERT INTO materia(codigo, nombre, observaciones, id_alumno) VALUES (55, ''TADP'', ''Nothing'', 1) '.
	result := conn execute: insert.
	self
		should: [result class = DBXResult].
	drop := 'drop table curso'.
	result := conn execute: drop.
	self
		should: [result class = DBXResult].
	conn disconnect! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 7/11/2008 15:43'!
testDisconnectBeforeQuery
	| conn select |
	conn := self doConnectAndOpen.
	conn disconnect.
	select := 'SELECT * FROM materia'.
	self
		should: [conn execute: select]
		raise: DBXError.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 9/27/2008 15:39'!
testEmptyResultSet
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia where codigo = 99999'.
	result := conn execute: select.	
	aRow := result nextRow.	
	self assert: aRow isNil.
	result release.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 9/27/2008 15:40'!
testEmptyResultSetRows
	| conn result select rows |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM curso'.
	result := conn execute: select.	
	rows := result nextRow.	
	self assert: rows isNil.
	result release.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'MMP 2/3/2009 00:52'!
testHasRowsEmptyResultSet
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia where codigo = 99999'.
	result := conn execute: select.	
	aRow := result nextRow.	
	result release.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 9/27/2008 15:41'!
testIterateResultSet
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM alumno'.
	result := conn execute: select.
	[ aRow := result nextRow ] doWhileTrue: [ aRow notNil ].
	self assert: aRow isNil.
	result release.
	conn disconnect! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 9/27/2008 15:39'!
testMultipleSelect
	| conn result select |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM materia'.
	result := conn execute: select.
	result release.
	result := conn execute: select.
	result release.
	result := conn execute: select.
	DBXTranscript show: result.
	result release.
	result := conn execute: select.
	DBXTranscript show: result.
	result := conn execute: select.
	DBXTranscript show: result.
	result release.
	result := conn execute: select.
	result release.
	result := conn execute: select.
	result release.
	result release.
	result := conn execute: select.
	result := conn execute: select.
	result := conn execute: select.
	DBXTranscript show: result.
	result := conn execute: select.
	DBXTranscript show: result.
	result := conn execute: select.
	DBXTranscript show: result.
	result := conn execute: select.
	result := conn execute: select.
	conn close.
	conn disconnect! !

!DBXQueryTest methodsFor: 'tests' stamp: 'MMP 8/7/2008 02:09'!
testNextRowAfterCloseResultSet
	| conn select result |

	select := 'SELECT * FROM materia'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	conn close.
	self should: [ result nextRow ] raise: DBXError.
	conn disconnect.
	
	
	
	! !

!DBXQueryTest methodsFor: 'tests' stamp: 'MMP 8/5/2008 22:02'!
testNextRowAfterDisconnect
	| conn select result |
	select := 'SELECT * FROM materia'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	conn disconnect.
	"I have closed de connection, so this should rise an error"
	self
		should: [result nextRow]
		raise: DBXError! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 9/27/2008 15:40'!
testNextRowAfterFinalizeResultSet
	| conn select result |

	select := 'SELECT * FROM materia'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	result release.
	
	"I have closed de resultSet, so this should rise an error"	
	self should: [ result nextRow ] raise: DBXError.
	
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'MMP 8/9/2008 22:20'!
testPrintARow
	| conn aResult select aRow stream |
	conn := self doConnectAndOpen.

	select := 'SELECT * FROM alumno'.
	aResult := conn execute: select.
	aRow := aResult nextRow.	
	stream := String new writeStream.
	aRow values
	do: [:each | stream nextPutAll: each asString]
	separatedBy: [stream nextPutAll: ' | '].
	Transcript show: stream contents;
	cr.	
		
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'MMP 8/9/2008 22:22'!
testQueryAfterQueryWithPartialResutlIteration
	| conn aResult select aRow |
	conn := self doConnectAndOpen.

	select := 'SELECT * FROM alumno'.
	aResult := conn execute: select.
	aRow := aResult nextRow.	
	aRow := aResult nextRow.
	
	select := 'SELECT * FROM materia'.
	aResult := conn execute: select.
	aRow := aResult nextRow.
	aRow := aResult nextRow.

	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 9/27/2008 15:39'!
testQueryAfterQueryWithPartialResutlIterationWithFinalize
	| conn aResult select aRow |
	conn := self doConnectAndOpen.

	select := 'SELECT * FROM alumno'.
	aResult := conn execute: select.
	aRow := aResult nextRow.	
	aRow := aResult nextRow.

	aResult release.
	select := 'SELECT * FROM materia'.
	aResult := conn execute: select.
	aRow := aResult nextRow.	
	aRow := aResult nextRow.
	
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'MMP 8/8/2008 00:18'!
testQueryAfterQueryWithTotalResutlIteration
	| conn aResult select |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM alumno'.
	aResult := conn execute: select.
	aResult
		rowsDo: [:row | Transcript
				show: (row valueNamed: 'EDAD')].
	select := 'SELECT * FROM materia'.
	aResult := conn execute: select.
	aResult
		rowsDo: [:row | Transcript
				show: (row valueNamed: 'codigo')].
	conn disconnect! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/7/2008 17:35'!
testQueryFollowedByAnotherQuery
	| conn aRresult select |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM curso'.
	aRresult := conn execute: select.
	self
		shouldnt: [conn execute: select]
		raise: DBXError.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 9/27/2008 15:41'!
testReleaseAllQueryResultsAfterDisconnectResultSet
	| conn select result |

	select := 'SELECT * FROM materia'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	conn disconnect.
	self shouldnt: [ result release ] raise: DBXError.
	
	! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 9/27/2008 15:41'!
testReleaseAllQueryResultsTwiceResultSet
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia'.
	result := conn execute: select.
	result release .
	self shouldnt: [ result release  ] raise: DBXError.	
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 9/27/2008 15:37'!
testResultSetNextRow
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia'.
	result := conn execute: select.
	self shouldnt: [ result nextRow ] raise: DBXError.
	result release.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 9/27/2008 15:37'!
testResultSetWithData
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM alumno where id = 1'.
	result:= conn execute: select.
	aRow := result nextRow.
	self assert: aRow notNil.
	"to execute odbx_result_finish()".
	[ aRow notNil ] whileTrue: [ aRow := result nextRow ].
	result release.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 9/27/2008 15:37'!
testSelect
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia'.
	result := conn execute: select.	
	self shouldnt: [ result nextRow ] raise: DBXError.
	result release.
	conn disconnect.
	
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia'.
	result := conn execute: select.	
	DBXTranscript show: result.
	self should: [ result nextRow ] raise: DBXError.
	result release.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/10/2008 17:07'!
testWrongSQL
	| conn select |
	conn := self doConnectAndOpen.
	select:= 'THIS IS NOT VALID SQL'.
	self should: [ conn execute: select. ] raise: DBXError.
	conn disconnect.! !

DBXQueryBaseTest subclass: #DBXRowTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXRowTest methodsFor: 'tests' stamp: 'HMC 9/27/2008 15:37'!
testRawValueAt
	| conn result select aRow value |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM alumno where id = 1'.
	result := conn execute: select.
	aRow := result nextRow.
	self
		shouldnt: [value := aRow rawValueAt: 1]
		raise: DBXError.
	self assert: value class = ByteString.
	Transcript show: 'raw value: ' , value asString.
	self
		shouldnt: [value := aRow valueAt: 1]
		raise: DBXError.
	self assert: value class = SmallInteger.
	Transcript show: 'raw value: ' , value asString.
	result release.
	conn disconnect! !

!DBXRowTest methodsFor: 'tests' stamp: 'HMC 9/27/2008 15:37'!
testRawValueNamed
	| conn result select aRow value |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM alumno where id = 1'.
	result := conn execute: select.	
	aRow := result nextRow.
	self assert: [ (value :=aRow rawValueNamed: 'id') = 1 asString].
	result release.
	conn disconnect.
! !

!DBXRowTest methodsFor: 'tests' stamp: 'HMC 9/27/2008 15:38'!
testRawValueNamedNotFound
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT nombre_apellido FROM alumno where id = 1'.
	result := conn execute: select.	
	aRow := result nextRow.
	self should: [ (aRow rawValueNamed: 'id')] raise: DBXError.
	result release.
	conn disconnect.
! !

!DBXRowTest methodsFor: 'tests' stamp: 'HMC 9/27/2008 15:38'!
testRawValues
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT id, nombre_apellido,edad FROM alumno where id = 1'.
	result := conn execute: select.	
	aRow := result nextRow.
	self assert: aRow rawValues size = 3.
	result release.
	conn disconnect.
! !

DBXQueryBaseTest subclass: #DBXTransactionalManageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXTransactionalManageTest methodsFor: 'tests' stamp: 'HMC 10/24/2008 19:13'!
testTransactionCommit
	| conn result delete select |
	conn := self doConnectAndOpen.
	conn startTransaction.
	delete := 'delete from materia'.
	result := conn execute: delete.
	result release.
	conn commit.
	select := 'SELECT * FROM materia'.
	result := conn execute: select.
	self assert: result nextRow isNil.
	result release.
	conn disconnect! !

!DBXTransactionalManageTest methodsFor: 'tests' stamp: 'MMP 1/4/2009 22:13'!
testTransactionRollback
	| conn result delete select |
	conn := self doConnectAndOpen.
	conn startTransaction.
	delete := 'delete from materia'.
	conn execute: delete.
	conn rollback.
	select := 'select * from materia'.
	result := conn execute: select.
	self assert: result nextRow notNil.
	result release.
	conn disconnect! !

DBXBaseTest subclass: #DBXSetUpTearDownTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXSetUpTearDownTest methodsFor: 'running' stamp: 'MMP 9/13/2008 17:53'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXSetUpTearDownTest methodsFor: 'tests' stamp: 'MMP 1/27/2009 00:03'!
testSetUpTearDOwn
! !

DBXBaseTest subclass: #DBXTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXTypeTest methodsFor: 'tests' stamp: 'test 12/1/2008 01:45'!
platformMssqlPrepareDatetime: aConnection
	[ aConnection execute: 'DROP TABLE test_datetime_columns;' ]
	on: Error do: [ :e| "table exists" ].

	aConnection execute: '
		CREATE TABLE test_datetime_columns (
			datetime_date 			DATETIME,
			datetime_time 			DATETIME,
			datetime_timestamp 		DATETIME);'.

	aConnection execute: '
		INSERT INTO test_datetime_columns
			(datetime_date, datetime_time, datetime_timestamp)
		VALUES (''2008-01-20'', ''10:20:30'', ''2008-01-20 10:20:30'');'.
! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 18:24'!
platformMysqlPrepareDatetime: aConnection
	[ aConnection execute: 'DROP TABLE test_datetime_columns;' ]
	on: Error do: [ :e| "table exists" ].

	aConnection execute: '
		CREATE TABLE test_datetime_columns (
			datetime_date 			DATE,
			datetime_time 			TIME,
			datetime_timestamp 	DATETIME);'.

	aConnection execute: '
		INSERT INTO test_datetime_columns
			(datetime_date, datetime_time, datetime_timestamp)
		VALUES (''2008-01-20'', ''10:20:30'', ''2008-01-20 10:20:30'');'.
	! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 18:28'!
platformMysqlTestCharacter: aRow
	self assert: (aRow valueNamed: 'char_char') = 'test'.
! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 23:19'!
platformMysqlTestDatetime: aRow
	self assert: (aRow valueNamed: 'datetime_time') = (Time hour: 10 minute: 20 second: 30).
! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 23:16'!
platformOraclePrepareDatetime: aConnection 
	[aConnection execute: 'DROP TABLE test_datetime_columns']
		on: Error do: [:e | "table exists" e].
	aConnection execute: '
	CREATE TABLE test_datetime_columns (
			datetime_date 			DATE,
			datetime_timestamp 	TIMESTAMP)'.

	aConnection execute: '
          INSERT INTO test_datetime_columns
			(datetime_date, datetime_timestamp)
		VALUES (to_date(''2008-01-20 01:01:01'', ''yyyy-mm-dd hh:mi:ss''), to_date(''2008-01-20 10:20:30'', ''yyyy-mm-dd hh:mi:ss''))'! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 17:57'!
platformPgsqlPrepareDatetime: aConnection
	[ aConnection execute: 'DROP TABLE test_datetime_columns;' ]
	on: Error do: [ :e| "table exists" ].

	aConnection execute: '
		CREATE TABLE test_datetime_columns (
			datetime_date 			DATE,
			datetime_time 			TIME,
			datetime_timestamp 	TIMESTAMP);'.

	aConnection execute: '
		INSERT INTO test_datetime_columns
			(datetime_date, datetime_time, datetime_timestamp)
		VALUES (''2008-01-20'', ''10:20:30'', ''2008-01-20 10:20:30'');'.
! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 18:27'!
platformPgsqlTestBoolean
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self shouldnt: [
		conn execute: 'DROP TABLE IF EXISTS test_boolean_columns;'.
		conn execute: '
			CREATE TABLE test_boolean_columns (
				bool_boolean 	BOOLEAN);'.
		conn execute: '		
			INSERT INTO test_boolean_columns
				(bool_boolean)
				VALUES (true);' ]
		raise: DBXError.
		
	self shouldnt: [ resultSet := conn execute: 'SELECT * FROM test_boolean_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.
	self assert: (row valueNamed: 'bool_boolean').
		
	conn close.! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 18:28'!
platformPgsqlTestCharacter: aRow
	self assert: (aRow valueNamed: 'char_char') = 
		('test' padded: #right to: 10 with: Character space).
! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 23:19'!
platformPgsqlTestDatetime: aRow
	self assert: (aRow valueNamed: 'datetime_time') = (Time hour: 10 minute: 20 second: 30).
! !

!DBXTypeTest methodsFor: 'tests' stamp: 'MMP 9/25/2008 23:06'!
platformSqlite3PrepareDatetime: aConnection
	[ aConnection execute: 'DROP TABLE test_datetime_columns;' ]
	on: Error do: [ :e| "table exists" ].

	aConnection execute: '
		CREATE TABLE test_datetime_columns (
			datetime_date 			DATE,
			datetime_time 			TIME,
			datetime_timestamp 	TIMESTAMP);'.

	aConnection execute: '
		INSERT INTO test_datetime_columns
			(datetime_date, datetime_time, datetime_timestamp)
		VALUES (''2008-01-20'', ''10:20:30'', ''2008-01-20 10:20:30'');'.
! !

!DBXTypeTest methodsFor: 'running' stamp: 'EL 8/2/2008 12:27'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 18:26'!
testBoolean
	"Not all paltforms have Boolean type support"
	self platformCall: #testBoolean! !

!DBXTypeTest methodsFor: 'tests' stamp: 'MMP 8/19/2008 21:39'!
testCharacter
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self
		shouldnt: [[conn execute: 'DROP TABLE test_character_columns']
				on: Error
				do: [:e | "table exists"
					e].
		]
		raise: DBXError.
		conn execute: '
			CREATE TABLE test_character_columns (
				char_char		CHAR(10),
				char_varchar	VARCHAR(10))'.
			conn execute: '
			INSERT INTO test_character_columns
				(char_char, char_varchar)
				VALUES (''test'', ''test'')'.
	self
		shouldnt: [resultSet := conn execute: 'SELECT * FROM test_character_columns']
		raise: DBXError.
	row := resultSet rows first.
	self platformCall: #testCharacter: with: row.
	self assert: (row valueNamed: 'char_varchar')
			= 'test'.
	conn close! !

!DBXTypeTest methodsFor: 'tests' stamp: 'MMP 10/13/2008 19:15'!
testDatetime
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self shouldnt: [ self platformCall: #prepareDatetime: with: conn ]
		raise: DBXError.
		
	self shouldnt: [ resultSet := conn execute: 'SELECT * FROM test_datetime_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.

	"Sqlite3 doesn't store time and dates values in specific types but uses CLOB instead. We map CLOB with String, yo for Sqlite3 we have to compare the date with the string'"
	
	(self platform class = DBXSqlitePlatform) ifTrue:[
		
		self assert: (row valueNamed: 'datetime_date') = (Date year: 2008 month: 1 day: 20) yyyymmdd.
		
		self assert: (row valueNamed: 'datetime_timestamp') = 
			(TimeStamp 
				year: 2008 
				month: 1 
				day: 20 
				hour: 10 
				minute: 20 
				second: 30) yyyymmddhhmmss.	
		
	] ifFalse:[

	self assert: (row valueNamed: 'datetime_date') = (Date year: 2008 month: 1 day: 20).
	self assert: (row valueNamed: 'datetime_timestamp') = 
		(TimeStamp 
			year: 2008 
			month: 1 
			day: 20 
			hour: 10 
			minute: 20 
			second: 30).
			
	].


	"Not all platforms has the same behaivor (or types) for date-time, then I check specific 
	 behaivor separately"
	self platformCall: #testDatetime: with: row.
	
	conn close.! !

!DBXTypeTest methodsFor: 'tests' stamp: 'MMP 1/5/2009 17:16'!
testNumeric
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self
		shouldnt: [[conn execute: 'DROP TABLE test_numeric_columns']
				on: Error
				do: [:e | "table exists"
					e]]
		raise: DBXError.
	conn execute: '
			CREATE TABLE test_numeric_columns (
				number_decimal 	DECIMAL(5,2),
				number_real 		REAL,
				number_float 		FLOAT,
				number_smallint 	SMALLINT,
				number_integer 		INTEGER)'.
	conn execute: '
			INSERT INTO test_numeric_columns
				(number_decimal, number_real, number_float, number_smallint, number_integer)
				VALUES (42.2, 42.2, 42.2, 42, 42)'.
	self
		shouldnt: [resultSet := conn execute: 'SELECT * FROM test_numeric_columns']
		raise: DBXError.
	row := resultSet rows first.
	self assert: (row valueNamed: 'number_decimal')
			= 42.2.
	"Some databases, like ODBC with postgres return 42.20001 instead of 42.2. Because of this the roundTo."
	self assert: ((row valueNamed: 'number_real') roundTo: 0.01) = 42.2.
			
	self assert: (row valueNamed: 'number_float')
			= 42.2.
	self assert: (row valueNamed: 'number_smallint')
			= 42.
	self assert: (row valueNamed: 'number_integer')
			= 42.
	conn close! !

TestCase subclass: #DBXConnectionSettingsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXConnectionSettingsTest methodsFor: 'tests' stamp: 'MMP 7/10/2008 23:30'!
testValidateMethod
	"The method is distinct to zero"
	| settings |
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: 5.
	self
		should: [settings validateMethod]
		raise: DBXError.
	"The method is distinct to zero"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: -5.
	self
		should: [settings validateMethod]
		raise: DBXError.
	"The method is distinct to zero"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: 'nothing'.
	self
		should: [settings validateMethod]
		raise: DBXError.
	"The method is distinct to zero"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: 0.
	self
		shouldnt: [settings validateMethod]
		raise: DBXError! !

!DBXConnectionSettingsTest methodsFor: 'tests' stamp: 'MMP 8/19/2008 21:18'!
xtestValidatePort
	| settings |
	
	self flag: #todo. "Validate port is not working with Pharo... so we are disabling this test for a while"
	
	"The port is negative but must be positive"
	settings := DBXConnectionSettings host: '127.0.0.1' port: '-1'. 
	self should: [ settings validatePort ] raise: DBXError.
	
	"The port is zero but must be positive"
	settings := DBXConnectionSettings host: '127.0.0.1' port: '0'. 
	self shouldnt: [settings validatePort] raise: DBXError.
	
	"The not a number but must be positive number"
	settings := DBXConnectionSettings host: '127.0.0.1' port: 'invalidPort'. 
	self should: [ settings validatePort ] raise: DBXError.
	
	"The port is correct"
	settings := DBXConnectionSettings host: '127.0.0.1' port: '88'. 
	self shouldnt: [settings validatePort] raise: DBXError.
		
! !

TestCase subclass: #DBXFullTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXFullTestRunner class methodsFor: 'as yet unclassified' stamp: 'MMP 1/9/2009 00:51'!
backendsToTest
	| backends |
	backends := Set new.
	backends add: DBXMainBackendTestPostgresql;
"	add: DBXMainBackendTestMySQL;"
"	add: DBXMainBackendTestOracle;	"
	add: DBXMainBackendTestSqlite.	
"	add: DBXMainBackendTestMSSQL;"
"	add: DBXMainBackendTestOdbcMSSQL;"
"	add: DBXMainBackendTestOdbcPosgtreSQL;"
	^backends
! !

!DBXFullTestRunner class methodsFor: 'as yet unclassified' stamp: 'MMP 1/9/2009 00:15'!
testsToTest
	| tests |
	tests := Set new.
	tests add: DBXCompleteExamplesTest;
	add: DBXConnectionTest;
	add: DBXDescriptionTest;
	add: DBXOptionsTest;
	add: DBXQueryDDLTest;
	add: DBXQueryDMLTest;
	add: DBXQueryTest;
	add: DBXRowTest;
	add: DBXTransactionalManageTest;
	add: DBXSetUpTearDownTest;
	add: DBXTypeTest;
	add: DBXConnectionSettingsTest.
^ tests! !

!DBXFullTestRunner methodsFor: 'tests' stamp: 'MMP 3/10/2009 22:30'!
test: aBackend times: aNumber
	| result resultTest testsCount |
	testsCount := 0.
	aNumber timesRepeat:[ 
		Transcript show: aBackend name ; cr.
		
	 	[result := aBackend suite run.]
			on: Error do:[ 'nothing' ].
		
		(result hasFailures or: [result hasErrors] ) ifTrue: [self fail].
		testsCount := testsCount + result passedCount.
		
		self class testsToTest do:[ :eachTest | [resultTest := eachTest suite run] on: Error do:['nothing'].
			
		(resultTest hasFailures or: [result hasErrors] ) ifTrue: [self fail].	
		testsCount := testsCount + resultTest passedCount.
			 ].
		].
	
		Transcript open.
		Transcript show: ('Total tests: ' , testsCount asString); cr.
		Transcript show: 'Tested backend: '; cr.
		Transcript show: (aBackend name); cr.
! !

!DBXFullTestRunner methodsFor: 'tests' stamp: 'MMP 1/9/2009 01:02'!
testAllBackendsWithAllTests
	| result resultTest testsCount |
	testsCount := 0.
	self class backendsToTest do:[ :each |
		Transcript show: each name ; cr.
		
	 	[result := each suite run.]
			on: Error do:[ 'nothing' ].
		
		(result hasFailures or: [result hasErrors] ) ifTrue: [self fail].
		testsCount := testsCount + result passedCount.
		
		self class testsToTest do:[ :eachTest | [resultTest := eachTest suite run] on: Error do:['nothing'].
			
		(resultTest hasFailures or: [result hasErrors] ) ifTrue: [self fail].	
		testsCount := testsCount + resultTest passedCount.
			 ].
		].
	
		Transcript open.
		Transcript show: ('Total tests: ' , testsCount asString); cr.
		Transcript show: 'Tested backends: '; cr.
		self class backendsToTest do:[ :each | Transcript show: (each name); cr. ].
		Transcript show: ('Total tests per backend: ' , (testsCount / self class backendsToTest size) asString ); cr.! !

TestCase subclass: #DBXMainBackendTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMainBackendTest methodsFor: 'facility' stamp: 'MMP 8/5/2008 01:23'!
facilityToTest
	self subclassResponsibility
	! !

!DBXMainBackendTest methodsFor: 'facility' stamp: 'MMP 8/5/2008 01:24'!
testSetToDBXBaseTestAFacility
	DBXBaseTest facility: self facilityToTest.
	! !

DBXMainBackendTest subclass: #DBXMainBackendTestMSSQL
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMainBackendTestMSSQL methodsFor: 'facility' stamp: 'MMP 1/11/2009 21:31'!
facilityToTest
	^DBXMsSQLFacility facilityForTest! !

DBXMainBackendTest subclass: #DBXMainBackendTestMySQL
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMainBackendTestMySQL methodsFor: 'facility' stamp: 'MMP 1/11/2009 21:32'!
facilityToTest
	^DBXMySQLFacility  facilityForTest! !

DBXMainBackendTest subclass: #DBXMainBackendTestOdbcMSSQL
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMainBackendTestOdbcMSSQL methodsFor: 'facility' stamp: 'MMP 1/11/2009 21:32'!
facilityToTest
	^ DBXOdbcMSSQLFacility facilityForTest! !

DBXMainBackendTest subclass: #DBXMainBackendTestOdbcPosgtreSQL
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMainBackendTestOdbcPosgtreSQL methodsFor: 'facility' stamp: 'MMP 1/11/2009 21:32'!
facilityToTest
	^ DBXOdbcPostgreFacility facilityForTest! !

DBXMainBackendTest subclass: #DBXMainBackendTestOracle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMainBackendTestOracle class methodsFor: '*OpenDBX-Core' stamp: 'MMP 8/6/2008 01:39'!
fromDbxString: aString 
	self shouldBeImplemented! !

!DBXMainBackendTestOracle methodsFor: 'facility' stamp: 'MMP 1/11/2009 21:34'!
facilityToTest
	^DBXOracleFacility facilityForTest! !

DBXMainBackendTest subclass: #DBXMainBackendTestPostgresql
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMainBackendTestPostgresql methodsFor: 'facility' stamp: 'MMP 1/11/2009 21:34'!
facilityToTest
	^DBXPostgreFacility facilityForTest! !

DBXMainBackendTest subclass: #DBXMainBackendTestSqlite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMainBackendTestSqlite methodsFor: 'facility' stamp: 'MMP 1/11/2009 21:35'!
facilityToTest
	^DBXSqliteFacility facilityForTest! !

Object subclass: #DBXAuthenticationMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXAuthenticationMethod class methodsFor: 'methods' stamp: 'MMP 8/16/2008 22:45'!
usernamePassword
	"Returns the method number of openDBX for username and password"
	^0.! !

Object subclass: #DBXBackendFacility
	instanceVariableNames: 'platform connectionSettings scriptsDDL scriptsDrops'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXBackendFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 1/9/2009 12:26'!
facilityForBenchmark
	^(self basicNew)
	createConnection;
	"addBenchmarkScripts"			
	yourself.! !

!DBXBackendFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 1/8/2009 17:40'!
facilityForTest
	^(self basicNew)
	createConnection;
	addTestScripts;			
	yourself.! !

!DBXBackendFacility methodsFor: 'tests' stamp: 'HMC 1/8/2009 17:24'!
addTestScripts
		""
	self subclassResponsibility! !

!DBXBackendFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 22:57'!
bigBenchmarkScriptInsert
	""
	self subclassResponsibility! !

!DBXBackendFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 22:57'!
bigBenchmarkScriptSelect
	""
	self subclassResponsibility! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
connectionSettings
	^ connectionSettings! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
connectionSettings: anObject
	connectionSettings := anObject! !

!DBXBackendFacility methodsFor: 'connection' stamp: 'HMC 1/8/2009 17:22'!
createConnection
		""
	self subclassResponsibility! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
platform
	^ platform! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
platform: anObject
	platform := anObject! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 8/7/2008 02:52'!
scriptsDDL
	^ scriptsDDL! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 8/7/2008 02:52'!
scriptsDDL: anObject
	scriptsDDL := anObject! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 10/5/2008 23:32'!
scriptsDrops
	^ scriptsDrops! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 10/5/2008 23:32'!
scriptsDrops: anObject
	scriptsDrops := anObject! !

!DBXBackendFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:15'!
tinyBenchmarkScript
		""
	self subclassResponsibility! !

!DBXBackendFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:15'!
tinyBenchmarkScript: aNumber
		""
	self subclassResponsibility! !

DBXBackendFacility subclass: #DBXMsSQLFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMsSQLFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 1/8/2009 17:39'!
new
	self error: 'Use facilityForTest or facilityForBenchmark'! !

!DBXMsSQLFacility methodsFor: 'tests' stamp: 'HMC 1/8/2009 17:39'!
addTestScripts
| scriptDDL scriptDrops |
scriptDDL := OrderedCollection new. 
	scriptDrops := OrderedCollection new. 
	
	scriptDDL add: 'CREATE TABLE alumno(
	   id INTEGER,
	   nombre_apellido VARCHAR(30) NULL,	   
	   regular BIT NULL,
	   edad SMALLINT NULL,	   
	   promedio DECIMAL(9,3) NULL,
	   sexo CHARACTER(3) NULL,
	   descripcion VARCHAR(200) NULL,
	   hora_ingreso DATETIME NULL,
	   fecha_alta DATETIME NULL,
	   fecha_nacimiento DATETIME NULL,
	  CONSTRAINT pk_alumnos_id PRIMARY KEY (id)
	) ;
'.

	
	scriptDDL add:  'CREATE TABLE materia(
	codigo INTEGER, 
	id_alumno INTEGER,
	nombre CHAR(35) NULL,
	observaciones VARCHAR(255) NULL,
	nota_parcial INTEGER NULL,
	nota_final INTEGER NULL,
	CONSTRAINT pk_materias_codigo PRIMARY KEY (codigo)
)  '.


	scriptDDL add:  
'CREATE TABLE curso(
	id_curso INTEGER,
	id_alumno INTEGER,
	codigo_materia INTEGER,
	Fecha_inicio DATETIME NULL,
	CONSTRAINT pk_cursos_id_curso PRIMARY KEY (id_alumno, codigo_materia)
) '.


"		scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ao_fk FOREIGN KEY (id_alumno) REFERENCES alumno(id)'.  
		
			scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ma_fk FOREIGN KEY (codigo_materia) REFERENCES materia(codigo)'."
	
	"scriptDDL add: 'ALTER TABLE materia
	ADD CONSTRAINT ma_ao_fk FOREIGN KEY (id_alumno) REFERENCES alumno(id)'.
	"
	
	self scriptsDDL: scriptDDL. 
	
	scriptDrops add: 'DROP TABLE curso'.
	scriptDrops add: 'DROP TABLE materia'. 
	scriptDrops add: 'DROP TABLE alumno'.
	
	self scriptsDrops: scriptDrops.! !

!DBXMsSQLFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 22:57'!
bigBenchmarkScriptInsert
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1	DATETIME,
			date2    DATETIME)'.
	^ scriptDDL! !

!DBXMsSQLFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 22:58'!
bigBenchmarkScriptSelect
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_select (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1	DATETIME,
			date2    DATETIME)'.
	^ scriptDDL! !

!DBXMsSQLFacility methodsFor: 'connection' stamp: 'HMC 1/8/2009 17:38'!
createConnection
self connectionSettings: (DBXConnectionSettings
				host: 'SQLSERVER_TDS'
				"host: '169.254.96.198'"
				port: '3004'
				database: 'sodbxtest'
				userName: 'crapodino'
				userPassword: 'florynano').
	self platform: DBXMSSQLPlatform new.! !

!DBXMsSQLFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:37'!
tinyBenchmarkScript
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
				CREATE TABLE tiny_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATETIME,
			date2 	DATETIME)'.
	^ scriptDDL! !

!DBXMsSQLFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:31'!
tinyBenchmarkScript: aNumber 
	| script |
	script := OrderedCollection new.
	script add: '
		CREATE TABLE tiny_benchmark_' , aNumber asString , ' (
			id 		INTEGER,
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATETIME,
			PRIMARY KEY (id))'.
	1
		to: aNumber
		do: [:i | script
				add: ('INSERT INTO tiny_benchmark_' , aNumber asString , ' 
					(id, num1, num2, num3, num4, str1, str2, date1)
				VALUES 
					({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8})' format: (OrderedCollection new add: i asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asDbxString;
							 add: i asString asDbxString;
							 add: i asString asDbxString;
							 add: DateAndTime current asDbxString;
							 yourself))].
	^ script! !

DBXBackendFacility subclass: #DBXMySQLFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMySQLFacility class methodsFor: 'instance creation' stamp: 'HMC 1/8/2009 17:08'!
new
	self error: 'Use facilityForTest or facilityForBenchmark'
! !

!DBXMySQLFacility methodsFor: 'tests' stamp: 'HMC 1/8/2009 17:31'!
addTestScripts
| scriptDDL scriptDrops  |
	scriptDDL := OrderedCollection new. 
	scriptDrops := OrderedCollection new. 
	
	scriptDDL add: 'CREATE TABLE alumno(
	   id INTEGER AUTO_INCREMENT,
	   usuario VARCHAR(10),
	   contrasenia VARCHAR(50),
	   mail VARCHAR(50),
	   nombre_apellido VARCHAR(30),	   
	   regular BOOLEAN,
	   edad SMALLINT,	   
	   promedio DECIMAL(9,3),
	   sexo CHARACTER(3),
	   descripcion VARCHAR(200),
	   hora_ingreso TIME,
	   fecha_alta DATETIME,
	   fecha_nacimiento DATE,
	  CONSTRAINT pk_alumnos_id PRIMARY KEY (id)
	) ENGINE = InnoDB ;
'.
"The InnoDB engine is in order to have transaction in this table"
	
	scriptDDL add:  'CREATE TABLE materia(
	codigo INTEGER, 
	id_alumno INTEGER,
	nombre CHAR(100),
	observaciones VARCHAR(255),
	nota_parcial INTEGER,
	nota_final INTEGER,
	CONSTRAINT pk_materias_codigo PRIMARY KEY (codigo)
) ENGINE = InnoDB '.
"The InnoDB engine is in order to have transaction in this table"

	scriptDDL add:  
'CREATE TABLE curso(
	id_curso INTEGER,
	id_alumno INTEGER,
	codigo_materia INTEGER,
	Fecha_inicio DATE,
	CONSTRAINT pk_cursos_id_curso PRIMARY KEY (id_alumno, codigo_materia)
) ENGINE = InnoDB '.
"The InnoDB engine is in order to have transaction in this table"

"		scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ao_fk FOREIGN KEY (id_alumno) REFERENCES alumno(id)'.  
		
			scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ma_fk FOREIGN KEY (codigo_materia) REFERENCES materia(codigo)'."
	
	scriptDDL add: 'ALTER TABLE materia
	ADD CONSTRAINT ma_ao_fk FOREIGN KEY (id_alumno) REFERENCES alumno(id)'.
	
	self scriptsDDL: scriptDDL. 
	
	scriptDrops add: 'DROP TABLE curso'.
	scriptDrops add: 'DROP TABLE materia'. 
	scriptDrops add: 'DROP TABLE alumno'.
	
	self scriptsDrops: scriptDrops.
! !

!DBXMySQLFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:17'!
bigBenchmarkScriptInsert
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	DATETIME)'.
	^ scriptDDL! !

!DBXMySQLFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:17'!
bigBenchmarkScriptSelect
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_select (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	DATETIME)'.
	^ scriptDDL! !

!DBXMySQLFacility methodsFor: 'connection' stamp: 'HMC 1/8/2009 17:50'!
createConnection
self connectionSettings: (DBXConnectionSettings
			host: '127.0.0.1'
			port: '3306'
			database: 'sodbxtest'
			userName: 'sodbxtest'
			userPassword: 'sodbxtest').
self platform: DBXMySQLPlatform new.


! !

!DBXMySQLFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:37'!
tinyBenchmarkScript
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
				CREATE TABLE tiny_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	DATETIME)'.
	^ scriptDDL! !

!DBXMySQLFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:18'!
tinyBenchmarkScript: aNumber 
	| script |
	script := OrderedCollection new.
	script add: '
		CREATE TABLE tiny_benchmark_' , aNumber asString , ' (
			id 		INTEGER,
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2    TIME,
			date3 	DATETIME,
			PRIMARY KEY (id))'.
	1
		to: aNumber
		do: [:i | script
				add: ('INSERT INTO tiny_benchmark_' , aNumber asString , ' 
					(id, num1, num2, num3, num4, str1, str2, date1, date2, date3)
				VALUES 
					({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9}, {10})' format: (OrderedCollection new add: i asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asDbxString;
							 add: i asString asDbxString;
							 add: i asString asDbxString;
							 add: Date current asDbxString;
							 add: Time current asDbxString;
							 add: DateAndTime current asDbxString;
							 yourself))].
	^ script! !

DBXBackendFacility subclass: #DBXOdbcMSSQLFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXOdbcMSSQLFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 1/8/2009 17:46'!
new
	self error: 'Use facilityForTest or facilityForBenchmark'
! !

!DBXOdbcMSSQLFacility methodsFor: 'tests' stamp: 'HMC 1/8/2009 17:52'!
addTestScripts
	| scriptDDL scriptDrops |
	scriptDDL := OrderedCollection new.
	scriptDrops := OrderedCollection new.
	scriptDDL add: 'CREATE TABLE alumno(
	   id INTEGER,
	   nombre_apellido VARCHAR(30) NULL,	   
	   regular BIT NULL,
	   edad SMALLINT NULL,	   
	   promedio DECIMAL(9,3) NULL,
	   sexo CHARACTER(3) NULL,
	   descripcion VARCHAR(200) NULL,
	   hora_ingreso DATETIME NULL,
	   fecha_alta DATETIME NULL,
	   fecha_nacimiento DATETIME NULL,
	  CONSTRAINT pk_alumnos_id PRIMARY KEY (id)
	) ;
'.
	scriptDDL add: 'CREATE TABLE materia(
	codigo INTEGER, 
	id_alumno INTEGER,
	nombre CHAR(35) NULL,
	observaciones VARCHAR(255) NULL,
	nota_parcial INTEGER NULL,
	nota_final INTEGER NULL,
	CONSTRAINT pk_materias_codigo PRIMARY KEY (codigo)
)  '.
	scriptDDL add: 'CREATE TABLE curso(
	id_curso INTEGER,
	id_alumno INTEGER,
	codigo_materia INTEGER,
	Fecha_inicio DATETIME NULL,
	CONSTRAINT pk_cursos_id_curso PRIMARY KEY (id_alumno, codigo_materia)
) '.
	"scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ao_fk FOREIGN KEY (id_alumno) REFERENCES
	alumno(id)'. 
	
	scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ma_fk FOREIGN KEY (codigo_materia) REFERENCES
	materia(codigo)'. "
	"scriptDDL add: 'ALTER TABLE materia
	ADD CONSTRAINT ma_ao_fk FOREIGN KEY (id_alumno) REFERENCES
	alumno(id)'. "
	self scriptsDDL: scriptDDL.
	scriptDrops add: 'DROP TABLE curso'.
	scriptDrops add: 'DROP TABLE materia'.
	scriptDrops add: 'DROP TABLE alumno'.
	self scriptsDrops: scriptDrops! !

!DBXOdbcMSSQLFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 22:57'!
bigBenchmarkScriptInsert
	! !

!DBXOdbcMSSQLFacility methodsFor: 'benchmarks' stamp: 'MMP 2/3/2009 01:20'!
bigBenchmarkScriptSelect
	! !

!DBXOdbcMSSQLFacility methodsFor: 'connection' stamp: 'HMC 1/8/2009 17:50'!
createConnection
	self connectionSettings: (DBXConnectionSettings 
		host: 'MSSQL'
		port: '3004'
		database: 'sodbxtest'
		userName: 'crapodino'
		userPassword: 'florynano').	
	self platform: DBXOdbcPlatform new.! !

!DBXOdbcMSSQLFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:29'!
tinyBenchmarkScript! !

!DBXOdbcMSSQLFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:29'!
tinyBenchmarkScript: aNumber ! !

DBXBackendFacility subclass: #DBXOdbcPostgreFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXOdbcPostgreFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 1/8/2009 17:45'!
new
	self error: 'Use facilityForTest or facilityForBenchmark'
! !

!DBXOdbcPostgreFacility methodsFor: 'tests' stamp: 'HMC 1/8/2009 17:56'!
addTestScripts
	| scriptDDL scriptDrops |
	scriptDDL := OrderedCollection new.
	scriptDrops := OrderedCollection new.
	scriptDDL add: 'CREATE TABLE alumno(
	   id SERIAL,
	   nombre_apellido VARCHAR,	
	   usuario VARCHAR(10),
        contrasenia VARCHAR(200),
	   mail VARCHAR(50),
        regular BOOLEAN,
	   edad SMALLINT,	   
	   promedio DECIMAL(9,3),
	   sexo CHARACTER(3),
	   descripcion VARCHAR,
	   hora_ingreso TIME,
	   fecha_alta TIMESTAMP,
	   fecha_nacimiento DATE,
	  CONSTRAINT pk_alumnos_id PRIMARY KEY (id)
	)'.
	scriptDDL add: 'CREATE TABLE materia(
	codigo INTEGER,
	id_alumno INTEGER, 
	nombre CHAR(100),
	observaciones VARCHAR(255),
	nota_parcial INTEGER,
	nota_final INTEGER,
	CONSTRAINT pk_materias_codigo PRIMARY KEY (id_alumno, codigo)
)'.
	scriptDDL add: 'CREATE TABLE curso(
	id_curso INTEGER,
	id_alumno INTEGER,
	codigo_materia INTEGER,
	Fecha_inicio DATE,
	CONSTRAINT pk_cursos_id_curso PRIMARY KEY (id_alumno, codigo_materia)
)'.
	"scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ao_fk FOREIGN KEY (id_alumno) REFERENCES
	alumno(id)'. scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ma_fk FOREIGN KEY (codigo_materia) REFERENCES
	materia(codigo)'. "
	scriptDDL add: 'ALTER TABLE materia
	ADD CONSTRAINT ma_ao_fk FOREIGN KEY (id_alumno) REFERENCES alumno(id)'.
	self scriptsDDL: scriptDDL.
	scriptDrops add: 'DROP TABLE curso'.
	scriptDrops add: 'DROP TABLE materia'.
	scriptDrops add: 'DROP TABLE alumno'.
	self scriptsDrops: scriptDrops! !

!DBXOdbcPostgreFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 22:57'!
bigBenchmarkScriptInsert
	! !

!DBXOdbcPostgreFacility methodsFor: 'benchmarks' stamp: 'MMP 2/3/2009 01:20'!
bigBenchmarkScriptSelect
	! !

!DBXOdbcPostgreFacility methodsFor: 'connection' stamp: 'HMC 1/8/2009 17:54'!
createConnection
	self connectionSettings:( DBXConnectionSettings 
		host: 'sodbxtest'
		port: '5432'
		database: 'sodbxtest'
		userName: 'sodbxtest'
		userPassword: 'sodbxtest').
	self platform: DBXOdbcPlatform new.! !

!DBXOdbcPostgreFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:29'!
tinyBenchmarkScript! !

!DBXOdbcPostgreFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:29'!
tinyBenchmarkScript: aNumber ! !

DBXBackendFacility subclass: #DBXOracleFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXOracleFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 1/8/2009 17:45'!
new
	self error: 'Use facilityForTest or facilityForBenchmark'
! !

!DBXOracleFacility methodsFor: 'tests' stamp: 'HMC 1/8/2009 18:01'!
addTestScripts
	| scriptDDL scriptDrops |
	scriptDDL := OrderedCollection new.
	scriptDrops := OrderedCollection new.
	scriptDDL add: 'CREATE table alumno (
    id               NUMBER NOT NULL,
    nombre_apellido  VARCHAR2(4000),
    usuario VARCHAR2(10),
    contrasenia VARCHAR2(50),
    mail VARCHAR2(50),
    regular          NUMBER(1),
    edad             NUMBER,
    promedio         NUMBER(9,3),
    sexo             VARCHAR2(4000),
    descripcion      VARCHAR2(4000),
    hora_ingreso     TIMESTAMP,
    fecha_alta       DATE,
    fecha_nacimiento DATE,
    constraint  alumno_PK primary key (id)
)
'.
	scriptDDL add: 'CREATE table materia (
    codigo        NUMBER NOT NULL,
    id_alumno INTEGER NOT NULL,
    nombre        VARCHAR2(4000),
    observaciones VARCHAR2(4000),
	nota_parcial NUMBER,
	nota_final NUMBER,
    constraint  materia_pk primary key (codigo)
)'.
	scriptDDL add: 'CREATE table curso (
    id_curso       NUMBER NOT NULL,
    id_alumno      NUMBER,
    codigo_materia NUMBER,
    fecha_inicio   DATE,
    constraint  curso2_pk primary key (id_curso)
)'.
	scriptDDL add: 'CREATE SEQUENCE alumno_id_seq 
 	       start with 1 
  	      increment by 1 
   	     nomaxvalue'.
	"scriptDDL add: 
	'CREATE TRIGGER alumno_insert_trigger
	before insert on alumno
	for each row
	begin
	select alumno_id_seq.nextval into :new.id from dual;
	end'."
	"
	scriptDDL add: '
	alter table curso add constraint
	co_ao_fk foreign key (id_alumno) references alumno (id)
	'. 
	
	scriptDDL add: 'alter table curso add constraint
	co_ma_fk foreign key (codigo_materia) references materia (codigo)
	'.
	
	scriptDDL add: 'ALTER TABLE materia
	ADD CONSTRAINT ma_ao_fk FOREIGN KEY (id_alumno) REFERENCES
	alumno(id)'. "
	self scriptsDDL: scriptDDL.
	scriptDrops add: 'DROP TABLE curso'.
	scriptDrops add: 'DROP TABLE materia'.
	scriptDrops add: 'DROP TABLE alumno'.
	scriptDrops add: 'DROP TRIGGER alumno_insert_trigger'.
	scriptDrops add: 'DROP SEQUENCE alumno_id_seq'.
	self scriptsDrops: scriptDrops! !

!DBXOracleFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:17'!
bigBenchmarkScriptInsert
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXOracleFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:17'!
bigBenchmarkScriptSelect
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_select (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXOracleFacility methodsFor: 'connection' stamp: 'HMC 1/8/2009 18:01'!
createConnection
self connectionSettings: (DBXConnectionSettings
				host: '127.0.0.1'
				port: '1521'
				database: 'xe'
				userName: 'sodbxtest'
				userPassword: 'sodbxtest').
	self platform: DBXOraclePlatform new.! !

!DBXOracleFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:26'!
tinyBenchmarkScript
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
				CREATE TABLE tiny_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXOracleFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:24'!
tinyBenchmarkScript: aNumber 
	| script |
	script := OrderedCollection new.
	script add: '
		CREATE TABLE tiny_benchmark_' , aNumber asString , ' (
			id 		INTEGER,
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP,
			PRIMARY KEY (id))'.
	1
		to: aNumber
		do: [:i | script
				add: ('INSERT INTO tiny_benchmark_' , aNumber asString , ' 
					(id, num1, num2, num3, num4, str1, str2, date1, date2)
				VALUES 
					({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9})' format: (OrderedCollection new add: i asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asDbxString;
							 add: i asString asDbxString;
							 add: i asString asDbxString;
							 add: Date current asDbxString;
							 add: DateAndTime current asDbxString;
							 yourself))].
	^ script! !

DBXBackendFacility subclass: #DBXPostgreFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXPostgreFacility class methodsFor: 'as yet unclassified' stamp: 'MMP 2/3/2009 01:49'!
new
	self error: 'Use facilityForTest or facilityForBenchmark'
! !

!DBXPostgreFacility methodsFor: 'tests' stamp: 'HMC 1/8/2009 18:03'!
addTestScripts
| scriptDDL scriptDrops |
scriptDDL := OrderedCollection new.
	scriptDrops := OrderedCollection new.
	scriptDDL add: 'CREATE TABLE alumno(
	   id SERIAL,
	   nombre_apellido VARCHAR,	
	   usuario VARCHAR(10),
        contrasenia VARCHAR(200),
	   mail VARCHAR(50),
        regular BOOLEAN,
	   edad SMALLINT,	   
	   promedio DECIMAL(9,3),
	   sexo CHARACTER(3),
	   descripcion VARCHAR,
	   hora_ingreso TIME,
	   fecha_alta TIMESTAMP,
	   fecha_nacimiento DATE,
	  CONSTRAINT pk_alumnos_id PRIMARY KEY (id)
	)'.
	scriptDDL add: 'CREATE TABLE materia(
	codigo INTEGER,
	id_alumno INTEGER, 
	nombre CHAR(100),
	observaciones VARCHAR(255),
	nota_parcial INTEGER,
	nota_final INTEGER,
	CONSTRAINT pk_materias_codigo PRIMARY KEY (id_alumno, codigo)
)'.
	scriptDDL add: 'CREATE TABLE curso(
	id_curso INTEGER,
	id_alumno INTEGER,
	codigo_materia INTEGER,
	Fecha_inicio DATE,
	CONSTRAINT pk_cursos_id_curso PRIMARY KEY (id_alumno, codigo_materia)
)'.

"	scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ao_fk FOREIGN KEY (id_alumno) REFERENCES alumno(id)'.
	scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ma_fk FOREIGN KEY (codigo_materia) REFERENCES materia(codigo)'."
	scriptDDL add: 'ALTER TABLE materia
	ADD CONSTRAINT ma_ao_fk FOREIGN KEY (id_alumno) REFERENCES alumno(id)'.
	
	self scriptsDDL: scriptDDL.
	scriptDrops add: 'DROP TABLE curso'.
	scriptDrops add: 'DROP TABLE materia'.
	scriptDrops add: 'DROP TABLE alumno'.
	self scriptsDrops: scriptDrops.! !

!DBXPostgreFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:09'!
bigBenchmarkScriptInsert
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXPostgreFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:09'!
bigBenchmarkScriptSelect
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_select (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXPostgreFacility methodsFor: 'connection' stamp: 'HMC 1/8/2009 18:03'!
createConnection
	self	connectionSettings: (DBXConnectionSettings
				host: '127.0.0.1'
				port: '5432'
				database: 'sodbxtest'
				userName: 'sodbxtest'
				userPassword: 'sodbxtest').
	self platform: DBXPostgresPlatform new! !

!DBXPostgreFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:12'!
tinyBenchmarkScript
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
				CREATE TABLE tiny_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXPostgreFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:13'!
tinyBenchmarkScript: aNumber 
	| script |
	script := OrderedCollection new.
	script add: '
		CREATE TABLE tiny_benchmark_' , aNumber asString , ' (
			id 		INTEGER,
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP,
			PRIMARY KEY (id))'.
	1
		to: aNumber
		do: [:i | script
				add: ('INSERT INTO tiny_benchmark_' , aNumber asString , ' 
					(id, num1, num2, num3, num4, str1, str2, date1, date2)
				VALUES 
					({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9})' format: (OrderedCollection new add: i asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asDbxString;
							 add: i asString asDbxString;
							 add: i asString asDbxString;
							 add: Date current asDbxString;
							 add: DateAndTime current asDbxString;
							 yourself))].
	^ script! !

DBXBackendFacility subclass: #DBXSqliteFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXSqliteFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 1/8/2009 17:45'!
new
	self error: 'Use facilityForTest or facilityForBenchmark'
! !

!DBXSqliteFacility methodsFor: 'tests' stamp: 'HMC 1/8/2009 18:05'!
addTestScripts
	| scriptDDL scriptDrops |
	scriptDDL := OrderedCollection new.
	scriptDrops := OrderedCollection new.
	scriptDDL add: 'CREATE TABLE alumno(
	   id INTEGER,
	   nombre_apellido CHARACTER VARYING(30),	   
	   usuario VARCHAR(10),
        contrasenia VARCHAR(10),
        mail VARCHAR(50),
        regular BOOLEAN,
	   edad SMALLINT,	   
	   promedio DECIMAL(9,3),
	   sexo CHARACTER(3),
	   descripcion CHARACTER VARYING(200),
	   hora_ingreso TIME,
	   fecha_alta TIMESTAMP,
	   fecha_nacimiento DATE,
	  CONSTRAINT pk_alumnos_id PRIMARY KEY (id)
	)'.
	scriptDDL add: 'CREATE TABLE materia(
	codigo INTEGER PRIMARY KEY,
	id_alumno INTEGER,
	nombre CHARACTER VARYING(50),
	nota_parcial INTEGER,
	nota_final INTEGER,
	observaciones CHARACTER VARYING(255)
)'.
	scriptDDL add: 'CREATE TABLE curso(
	id_curso INTEGER,
	id_alumno INTEGER,
	codigo_materia INTEGER,
	Fecha_inicio DATE,
	CONSTRAINT pk_cursos_id_curso PRIMARY KEY (id_alumno, codigo_materia)
)'.
	self scriptsDDL: scriptDDL.
	scriptDrops add: 'DROP TABLE curso'.
	scriptDrops add: 'DROP TABLE materia'.
	scriptDrops add: 'DROP TABLE alumno'.
	self scriptsDrops: scriptDrops! !

!DBXSqliteFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:18'!
bigBenchmarkScriptInsert
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXSqliteFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:18'!
bigBenchmarkScriptSelect
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_select (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXSqliteFacility methodsFor: 'connection' stamp: 'HMC 1/8/2009 18:04'!
createConnection
	self	connectionSettings: (DBXConnectionSettings
				host: '/home/mariano/sqlite/'
				port: ''
				database: 'sodbxtest.db'
				userName: ''
				userPassword: '').
	self platform: DBXSqlitePlatform new! !

!DBXSqliteFacility methodsFor: 'benchmarks' stamp: 'MMP 1/11/2009 22:01'!
tinyBenchmarkScript
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
				CREATE TABLE tiny_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXSqliteFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:28'!
tinyBenchmarkScript: aNumber 
	| script |
	script := OrderedCollection new.
	script add: '
		CREATE TABLE tiny_benchmark_' , aNumber asString , ' (
			id 		INTEGER,
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2    TIME,
			date3 	TIMESTAMP,
			PRIMARY KEY (id))'.
	1
		to: aNumber
		do: [:i | script
				add: ('INSERT INTO tiny_benchmark_' , aNumber asString , ' 
					(id, num1, num2, num3, num4, str1, str2, date1, date2, date3)
				VALUES 
					({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9}, {10})' format: (OrderedCollection new add: i asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asDbxString;
							 add: i asString asDbxString;
							 add: i asString asDbxString;
							 add: Date current asDbxString;
							 add: Time current asDbxString;
							 add: DateAndTime current asDbxString;
							 yourself))].
	^ script! !

Object subclass: #DBXBaseResult
	instanceVariableNames: 'connection handle description querySettings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXBaseResult class methodsFor: 'instance creation' stamp: 'HMC 9/27/2008 15:23'!
new
	self error: 'You must instanciate a subclass of DBXBaseResult'! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'HMC 9/27/2008 15:18'!
connection
	^ connection! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'HMC 9/27/2008 15:18'!
description
	^description! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'HMC 9/27/2008 15:18'!
description: aDescription 
	description := aDescription
! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'HMC 9/27/2008 15:18'!
handle
	^handle! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'HMC 9/27/2008 15:18'!
handle: aHandle 
	handle := aHandle
! !

!DBXBaseResult methodsFor: 'initialization' stamp: 'MMP 2/2/2009 20:13'!
initializeConnection: aConnection handle: aNumber description: aDescription querySettings: aQuerySettings 
	super initialize.
	connection := aConnection.
	handle := aNumber.
	description := aDescription.
	querySettings := aQuerySettings.! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'HMC 9/27/2008 15:19'!
platform
	^self connection platform! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'MMP 2/2/2009 20:12'!
querySettings
	^ querySettings! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'MMP 2/2/2009 20:12'!
querySettings: anObject
	querySettings := anObject! !

!DBXBaseResult methodsFor: 'finalization' stamp: 'MMP 3/1/2009 15:45'!
release
	"It will release all the resources of all the resultsSets associated with a
	query, if there is any"
	self subclassRisponsability! !

DBXBaseResult subclass: #DBXResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXResult class methodsFor: 'instance creation' stamp: 'MMP 8/16/2008 20:11'!
new
	self error: 'Use #on:handle:description:'! !

!DBXResult class methodsFor: 'instance creation' stamp: 'MMP 2/2/2009 19:15'!
on: aConnection handle: aNumber description: aDescription querySettings: aQuerySettings
	^(self basicNew)
		initializeConnection: aConnection 
			handle: aNumber
			description: aDescription
			querySettings: aQuerySettings;
		yourself.! !

!DBXResult methodsFor: 'testing' stamp: 'MMP 2/3/2009 00:47'!
release
	"Maybe in a future this method could do something"! !

!DBXResult methodsFor: 'accessing' stamp: 'MMP 8/16/2008 20:35'!
rowsAffected
	"Returns the number of rows that have been changed by the current statement. Affected rows are only returned for DELETE, INSERT or UPDATE statements and their concrete number depends on the database implementation. 
	
	This value depends on the type of query:

    * DDL query: It will always be zero.
    * Insert query: It will always be one.
    * Delete and update: Returns the number of rows that have been changed by the current statement. However, their concrete number depends on the database implementation. Instead returning the number of rows which are matched by the WHERE clause, MySQL for example does only count the rows whose values have really been changed. "
	
	^self description rowsAffected! !

DBXBaseResult subclass: #DBXResultSet
	instanceVariableNames: 'open'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXResultSet class methodsFor: 'instance creation' stamp: 'HMC 10/11/2008 11:08'!
new
	self error: 'Use #on:handle:description:pageSize:'! !

!DBXResultSet class methodsFor: 'instance creation' stamp: 'MMP 1/31/2009 20:39'!
on: aConnection handle: aNumber description: aDescription querySettings: aQuerySettings
	^(self basicNew)
		initializeConnection: aConnection 
			handle: aNumber
			description: aDescription
			querySettings: aQuerySettings;
		yourself.! !

!DBXResultSet methodsFor: 'enumerating' stamp: 'HMC 9/27/2008 15:59'!
allRowsDo: aBlock 
	"It will execute the block to each row from the collection"
	| rows |
	rows := self rows.
	rows do: aBlock! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 8/16/2008 20:25'!
columnCount
	"Returns the number of columns affected in the query. It will be the columns you specify in the select statement"
	^self description columnCount! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 8/16/2008 20:29'!
columnDescriptionAt: anIndex
	"Returns the column description at that index.
	IMPORTANT: The index starts in 1."
	^self description columnDescriptionAt: anIndex! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 12/22/2008 20:54'!
columnDescriptionWithName: aName 
	"Returns the column description with that name. If a column with that name was not in select statement a DBXError will be thrown"
	^ [self columnDescriptions
		detect: [:each | each name sameAs: aName]]
		on: Error
		do: [SqueakDBXError signal: 'A column with that name was not found' ]! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 8/16/2008 20:31'!
columnDescriptions
	"Returns the column description of ALL the affected columns"
	^self description columnDescriptions! !

!DBXResultSet methodsFor: 'finalization' stamp: 'MMP 8/16/2008 20:47'!
finalize
	"Will finalize the DBXResultSet object"
	self isOpen ifTrue: [ self finalizeResultSet ]! !

!DBXResultSet methodsFor: 'finalization' stamp: 'MMP 8/16/2008 20:46'!
finalizeResultSet
	"It will release resources and change internal state"
	self platform releaseResultSet: self.
	self internalBeClosed.! !

!DBXResultSet methodsFor: 'initialization' stamp: 'MMP 2/2/2009 20:14'!
initializeConnection: aConnection handle: aNumber description: aDescription querySettings: aQuerySettings 
	super
		initializeConnection: aConnection
		handle: aNumber
		description: aDescription
		querySettings: aQuerySettings.
	open := ValueHolder new contents: false.
	self internalBeOpen.! !

!DBXResultSet methodsFor: 'private' stamp: 'EL 6/27/2008 09:01'!
internalBeClosed
	open contents: false! !

!DBXResultSet methodsFor: 'private' stamp: 'EL 6/27/2008 09:01'!
internalBeOpen
	open contents: true! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 8/16/2008 20:31'!
isOpen
	"Returns if the DBXResultSet is open or not."
	^open contents! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 12/22/2008 20:54'!
nextRow
	"it returns the next row of the resultSet. If there is no more row, it returns nil. 
	
	VERY IMPORTANT THINGS:

    * After doing a select query you should call nextRow till it returns nil. If you don't do this, you will get a segmentation fault in your next query. You have to do this no matter which number of rows you have got. Suppose you are looking for some record and you find it in the second one. The number of rows is 10. In this case, you should call nextRow 10 times, no matter you found the record in the second one. This limitation is in the database client library. We assume that someone has to do this (retrieve all results before execute another query): openDBX, database client library, SqueakDBX or SqueakDBX user. So, we decided SqueakDBX should do this. The other approach was the SqueakDBX user should do it and if it doesn't do it, SqueakDBX throws an error. In conclusion, you DON'T need to call nextRow till nil its returned, the framework will do it for you in your next query.
    * Some queries return more than one resultSet. This situation will be transparent for SqueakDBX user. nextRow will automatically obtain next resultSet when needed. 

"
	| row |
	self isOpen
		ifFalse: [ SqueakDBXError signal: 'The resultSet must be open to obtain the next row but it is closed' ].
	row := self platform moveNext: self.
	row
		ifNil: [self internalBeClosed].
	^ row! !

!DBXResultSet methodsFor: 'finalization' stamp: 'HMC 9/27/2008 15:42'!
release
	"It will release all the resources of all the resultsSets associated with a query."
	self isOpen
		ifTrue: [self platform releaseAllQueryResultSets: self.
			self internalBeClosed]! !

!DBXResultSet methodsFor: 'enumerating' stamp: 'MMP 8/16/2008 20:43'!
rows
	"It returns in an OrderedCollection, ALL the rows of all the resultSets of a query"
	| results |
	results := OrderedCollection new.
	self rowsDo: [ :each| 
		results add: each ].
	^results! !

!DBXResultSet methodsFor: 'enumerating' stamp: 'MMP 8/16/2008 20:44'!
rowsDo: aBlock
	"It will execute the block to each row"
	| row |
	[ row := self nextRow.
	  row notNil ] 
	whileTrue: [ aBlock value: row ]! !

Object subclass: #DBXBenchmark
	instanceVariableNames: 'times mutex allTimes'
	classVariableNames: 'Facility'
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!DBXBenchmark class methodsFor: 'defaults' stamp: 'MMP 2/3/2009 01:18'!
defaultFacility
	^DBXPostgreFacility facilityForBenchmark! !

!DBXBenchmark class methodsFor: 'defaults' stamp: 'EL 8/20/2008 09:44'!
defaultInserts
	^800! !

!DBXBenchmark class methodsFor: 'defaults' stamp: 'EL 8/20/2008 09:44'!
defaultRows
	^10! !

!DBXBenchmark class methodsFor: 'defaults' stamp: 'MMP 1/11/2009 22:17'!
defaultRuns
	^10! !

!DBXBenchmark class methodsFor: 'accessing' stamp: 'EL 8/20/2008 09:26'!
facility
	^ Facility ifNil: [ Facility := self defaultFacility ]! !

!DBXBenchmark class methodsFor: 'accessing' stamp: 'EL 8/20/2008 09:26'!
facility: anObject
	Facility := anObject! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'EL 8/20/2008 18:54'!
allTimes
	^allTimes! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 8/20/2008 18:40'!
collect: aBlock
	self runs timesRepeat: [
		| timeExpended |
		timeExpended := MessageTally time: aBlock.
		mutex critical: [ times add: timeExpended ]]! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 7/1/2008 21:18'!
collectedTimeAverage
	^((times inject: 0 into: [ :v :each | v + each ]) / self class defaultRuns) asFloat! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 8/20/2008 09:30'!
createDbxConnection
	| connection |
	connection := DBXConnection
		platform: self facility platform
		settings: self facility connectionSettings.
	connection connect.
	connection open.
	
	^connection! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'EL 8/20/2008 09:27'!
facility
	^self class facility! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 7/1/2008 21:32'!
findBenchmarks
	^self class allSelectors asSortedCollection asOrderedCollection select: [:each | 
		('benchmark*' match: each) and: [each numArgs isZero]]! !

!DBXBenchmark methodsFor: 'initialization' stamp: 'EL 8/20/2008 18:55'!
initialize
	super initialize.
	allTimes := Dictionary new. 
	mutex := Monitor new. ! !

!DBXBenchmark methodsFor: 'initialization' stamp: 'MMP 1/20/2009 23:23'!
initializeDatabase
	| conn |
	conn := self createDbxConnection.
	self prepareData: conn rows: 10.
	self prepareData: conn rows: 100.
	self prepareData: conn rows: 1000.
	self prepareInsert: conn.
	conn close.! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'EL 7/1/2008 21:58'!
log: aString
	Transcript show: aString; cr.! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 8/20/2008 17:21'!
performIfExists: aSelector
	(self class allSelectors includes: aSelector)
		ifTrue: [ self perform: aSelector ]! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 7/1/2008 21:18'!
prepareCollector
	times := OrderedCollection new.
	! !

!DBXBenchmark methodsFor: 'initialization' stamp: 'MMP 1/20/2009 23:47'!
prepareData: aConnection rows: aNumber
	[ aConnection execute: 'DROP TABLE tiny_benchmark_', aNumber asString ]
	on: DBXError do: [ :e | "DROP fails" ].
	
		(self facility tinyBenchmarkScript: aNumber)
		do: [:script | aConnection execute: script].
	! !

!DBXBenchmark methodsFor: 'initialization' stamp: 'MMP 1/20/2009 23:47'!
prepareInsert: aConnection
	[ aConnection execute: 'DROP TABLE tiny_benchmark_insert' ]
	on: DBXError do: [ :e | "DROP fails" ].

	(self facility tinyBenchmarkScript)
		do: [:script | aConnection execute: script].
! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/20/2008 20:58'!
run: aSelector
	self prepareCollector.
	self setUp.
	self setUpFor: aSelector.
	self collect: [ self perform: aSelector ].
	self tearDownFor: aSelector.
	self tearDown.
	mutex critical: [
		allTimes at: aSelector put: self collectedTimeAverage.
		self log: aSelector, ': ', self collectedTimeAverage asString, ' AVG' ].! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/20/2008 19:16'!
runAll
	self log: 'Benchmarking: ', self class name, ' (', self runs asString, ' runs)'.
	self findBenchmarks do: [ :each | 
		self run: each ].! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/20/2008 21:10'!
runAllForked
	self log: 'Benchmarking: ', self class name, ' (', self runs asString, ' runs)'.
	self findBenchmarks do: [ :each | 
		self runForked: each ].! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/20/2008 21:51'!
runAllForked: aPriorityNumber
	self log: 'Benchmarking: ', self class name, ' (', self runs asString, ' runs)'.
	self findBenchmarks do: [ :each | 
		self runForked: each priority: aPriorityNumber ].! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/20/2008 21:50'!
runForked: aSelector
	self runForked: aSelector priority: Processor userBackgroundPriority.! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/20/2008 21:51'!
runForked: aSelector priority: aPriorityNumber
	[ self run: aSelector ] forkAt: aPriorityNumber.! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'EL 7/1/2008 21:31'!
runs
	^self class defaultRuns ! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/20/2008 09:28'!
setUp
	! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/20/2008 17:22'!
setUpFor: aSelector
	self performIfExists: ('setUp', aSelector capitalized) asSymbol! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 7/2/2008 11:55'!
tearDown! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/20/2008 17:22'!
tearDownFor: aSelector
	self performIfExists: ('tearDown', aSelector capitalized) asSymbol! !

DBXBenchmark subclass: #DBXBigBenchmarks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!DBXBigBenchmarks class methodsFor: 'defaults' stamp: 'EL 8/20/2008 17:28'!
defaultRuns
	^1! !

!DBXBigBenchmarks methodsFor: 'running' stamp: 'MMP 1/12/2009 22:56'!
benchmarkInsert100000
	| connection |
	connection := self createDbxConnection.
	100000 timesRepeat: [ 
		connection execute: 
			'INSERT INTO big_benchmark_insert
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')' ].
	connection close.	! !

!DBXBigBenchmarks methodsFor: 'running' stamp: 'MMP 1/12/2009 22:55'!
benchmarkSelect100000
	| connection |
	connection := self createDbxConnection.
	(connection execute: 'SELECT * FROM big_benchmark_select')
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ] ].
	connection := self createDbxConnection.! !

!DBXBigBenchmarks methodsFor: 'running' stamp: 'MMP 1/12/2009 23:10'!
setUpBenchmarkInsert100000
	| connection |
	connection := self createDbxConnection.
	[ connection execute: 'DROP TABLE big_benchmark_insert' ] 
		on: DBXError
		do: 
			[ :e | 
			"DROP fails"
			 ].
	self facility bigBenchmarkScriptInsert do: 
		[ :script | 
		connection execute: script ].
	connection close! !

!DBXBigBenchmarks methodsFor: 'running' stamp: 'MMP 1/12/2009 23:13'!
setUpBenchmarkSelect100000
	| connection |
	connection := self createDbxConnection.
	[ connection execute: 'DROP TABLE big_benchmark_select' ] 
		on: DBXError
		do: 
			[ :e | 
			"DROP fails"
			 ].
	self facility bigBenchmarkScriptSelect do: 
		[ :script | 
		connection execute: script ].
	100000 timesRepeat: 
		[ connection execute: 'INSERT INTO big_benchmark_select
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')' ].
	connection close! !

!DBXBigBenchmarks methodsFor: 'running' stamp: 'MMP 1/12/2009 22:55'!
tearDownBenchmarkInsert100000
	| connection |
	connection := self createDbxConnection.
	connection execute: 'DROP TABLE big_benchmark_insert'.
	connection close.! !

!DBXBigBenchmarks methodsFor: 'running' stamp: 'MMP 1/20/2009 23:36'!
tearDownBenchmarkSelect100000
	| connection |
	connection := self createDbxConnection.
	connection execute: 'DROP TABLE big_benchmark_select'.
	connection close.! !

DBXBenchmark subclass: #DBXTinyBenchmarks
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 09:21'!
benchmarkInsert
	self class defaultInserts timesRepeat: [ 
		connection execute: 
			'INSERT INTO tiny_benchmark_insert  
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')' ]
! !

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 09:21'!
benchmarkInsertConverted
	| date dateAndTime |
	
	date := Date current. 
	dateAndTime := DateAndTime current. 
	1 to: self class defaultInserts do: [ :i |  
		connection execute: (
			'INSERT INTO tiny_benchmark_insert  
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES ({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8})' 
					format: (OrderedCollection new
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asDbxString;
						add: i asString asDbxString;
						add: i asString asDbxString;
						add: date asDbxString;
						add: dateAndTime asDbxString;
						yourself)) ]
! !

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 11:53'!
benchmarkSelect10
	(connection execute: 'SELECT * FROM tiny_benchmark_10')
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ] ].! !

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 11:53'!
benchmarkSelect100
	(connection execute: 'SELECT * FROM tiny_benchmark_100')
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ] ].! !

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 11:53'!
benchmarkSelect1000
	(connection execute: 'SELECT * FROM tiny_benchmark_1000')
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ] ].! !

!DBXTinyBenchmarks methodsFor: 'initialization' stamp: 'EL 8/20/2008 18:41'!
initialize
	super initialize.
	self initializeDatabase.
	self initializeConnection.! !

!DBXTinyBenchmarks methodsFor: 'initialization' stamp: 'EL 8/20/2008 09:30'!
initializeConnection
	connection := self createDbxConnection.
! !

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 09:34'!
setUp
	self prepareInsert: connection.! !

DBXBenchmark subclass: #PGTinyBenchmarks
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 10:16'!
benchmarkInsert
	self class defaultInserts timesRepeat: [ 
		connection execute: 
			'INSERT INTO tiny_benchmark_insert  
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')' ]
! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 10:11'!
benchmarkInsertConverted
	| date dateAndTime |
	
	date := Date current. 
	dateAndTime := DateAndTime current. 
	1 to: self class defaultInserts do: [ :i |  
		connection execute: (
			'INSERT INTO tiny_benchmark_insert  
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES ({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8})' 
					format: (OrderedCollection new
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asDbxString;
						add: i asString asDbxString;
						add: i asString asDbxString;
						add: date asDbxString;
						add: dateAndTime asDbxString;
						yourself)) ]
! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 11:53'!
benchmarkSelect10
	(connection  execute: 'SELECT * FROM tiny_benchmark_10') lastResultSet 
		in: [ :resultSet |
			resultSet rows do: [ :each | each data ] ]  ! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 11:53'!
benchmarkSelect100
	(connection  execute: 'SELECT * FROM tiny_benchmark_100') lastResultSet 
		in: [ :resultSet |
			resultSet rows do: [ :each | each data ] ]  ! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 11:54'!
benchmarkSelect1000
	(connection  execute: 'SELECT * FROM tiny_benchmark_1000') lastResultSet 
		in: [ :resultSet |
			resultSet rows do: [ :each | each data ] ]  ! !

!PGTinyBenchmarks methodsFor: 'initialization' stamp: 'EL 8/20/2008 18:41'!
initialize
	super initialize.
	self initializeDatabase.
	self initializeConnection.! !

!PGTinyBenchmarks methodsFor: 'initialization' stamp: 'EL 7/26/2008 13:07'!
initializeConnection
	connection := PGConnection new
		connectionArgs: (PGConnectionArgs new
			hostname: 'localhost';
			portno: 5432;
			databaseName: 'sodbxtest';
			userName: 'sodbxtest';
			password: 'sodbxtest');
		yourself.
	connection startup.
! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 09:35'!
setUp
	| conn |
	conn := self createDbxConnection.
	self prepareInsert: conn.
	conn close.! !

Object subclass: #DBXColumnDescription
	instanceVariableNames: 'type dbxType name size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Description'!

!DBXColumnDescription class methodsFor: 'instance creation' stamp: 'HMC 8/16/2008 21:16'!
name: aString dbxType: aNumber type: aType
"this instantiates a new DBXColumnDescription with a type size of zero"
	^self name: aString dbxType: aNumber type: aType size: 0! !

!DBXColumnDescription class methodsFor: 'instance creation' stamp: 'HMC 8/16/2008 21:18'!
name: aNameString dbxType: aNumber type: aTypeSymbol size: aTypeSizeNumber
"this instantiates a new DBXColumnDescription, whitch will hold the name, data type and size of the data type the rows from the database have"
	^(super new)
		name: aNameString;
		type: aTypeSymbol;
		size: aTypeSizeNumber;
		yourself.! !

!DBXColumnDescription class methodsFor: 'instance creation' stamp: 'EL 3/31/2008 11:58'!
new
	self error: 'Use caption:type:'! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 20:56'!
dbxType
"this is the data type of this column, according to its data type from the database"
	^ dbxType! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 8/3/2008 08:45'!
dbxType: anObject
	dbxType := anObject! !

!DBXColumnDescription methodsFor: 'testing' stamp: 'HMC 8/16/2008 20:54'!
isLarge
"see DBXPlatform isLarge"
	^DBXPlatform isLarge: self dbxType! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 20:57'!
name
"this is the name of this column, according to its database name, "
	^name! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 6/27/2008 19:49'!
name: aString
	name := aString! !

!DBXColumnDescription methodsFor: 'printing' stamp: 'EL 6/27/2008 20:45'!
printOn: aStream
	aStream nextPut: $(.
	self name printOn: aStream.
	aStream nextPut: $:.
	self type printOn: aStream.
	aStream nextPut: $).! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:15'!
size
"size of the data type"
	^size! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 6/27/2008 19:50'!
size: aNumber
	size := aNumber! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 20:59'!
type
"type of the data that a column description holds"
	^ type! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 3/31/2008 11:24'!
type: anObject
	type := anObject! !

Object subclass: #DBXConnection
	instanceVariableNames: 'platform settings handle open connected result queryTimeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXConnection class methodsFor: 'initialization' stamp: 'MMP 4/15/2008 00:37'!
initialize
	"DBConnection initialize"

	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!DBXConnection class methodsFor: 'logging' stamp: 'EL 5/12/2008 18:50'!
log: message
	Transcript show: message; cr.! !

!DBXConnection class methodsFor: 'instance creation' stamp: 'EL 7/1/2008 16:51'!
platform: aPlatform settings: aConnectionSettings
	^self new
		platform: aPlatform;
		settings: aConnectionSettings;
		yourself! !

!DBXConnection class methodsFor: 'system startup' stamp: 'MMP 9/14/2008 20:03'!
shutDown
	self
		allInstancesDo: [:each | each shutDown]! !

!DBXConnection class methodsFor: 'system startup' stamp: 'EL 7/1/2008 20:52'!
startUp
	"Right now i do nothing in the startup. Perhaps in a future I should open the connections that were closed when the image was down"
"	self allInstancesDo: [ :each| each startUp ]."! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 5/12/2008 18:45'!
= aDBXConnection
	^ self handle = aDBXConnection handle.! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 12/22/2008 20:47'!
close
	"It closes the connection releasing all the resultSets. It will probably free tcp/ip database connection. You must re open it in order to execute more queries"
	self isOpen
		ifFalse: [SqueakDBXError signal: 'The connection is not open. Try opening it first'].
	self releaseResultSets.
	self platform closeConnection: self.
	self internalBeClosed! !

!DBXConnection methodsFor: 'transactional manage' stamp: 'MMP 2/3/2009 01:01'!
commit
	"executes a commit statement"
	| aResult |
	self isOpen ifFalse: 
		[ SqueakDBXError signal: 'You cannot commit if the connection is not open' ].
	self result ifNotNil: [ self result release ].	"sacar esto a un metodo"
	aResult := self platform commit: self.
	self result: aResult.
	^ self result! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 12/22/2008 20:48'!
connect
	"This is the first method that must be called to a connection. It connects to database host and creates all the data structure for a connection. After it, you can call open. You cannot connect an already connected connection"
	self isConnected
		ifTrue: [SqueakDBXError signal: 'You are already connected. Try disconnecting first' ].
	self validateSettingsForConnect.
	"WARNING This is the only place where we have direct access to
	handles... "
	handle := self platform createConnection: self.
	WeakRegistry default add: self.
	self internalBeConnected.
	
! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 3/1/2009 15:43'!
connectAndOpen
"Take into consideration that using this method you cannot specify special options because 
many of them should be called between connect and open operations
In case you don't want to use any SqueakDBX special options, you can use this message. However, we recommend to use connect and open separately"	
	self connect.
	self open.! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 12/22/2008 20:42'!
disconnect
	" Disconnect from database releasing all resultSets. No operation will be permitted after it. It must be call when you finish using the connection. If the connection wasn't close, it will do it. In order to do a disconnection, the connection must be connected'"
	self isConnected
		ifFalse: [^ nil].
	self isOpen
		ifTrue: [self close].
	self releaseConnection.
	self internalBeDisconnected.
	handle := nil! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/12/2008 01:29'!
enableCompression
	"It tries to enable Compression option. If it can, it activates the option, returns true and you can use that option. If not, it will return false. So you must ask the return on this method in order to now what to do."
	^self enableSpecialOption: DBXSpecialOptions compression.! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/23/2008 20:27'!
enableEncryption: aEncryptionOption
"It tries to enable Encryption option. If it can, it activates the option, returns true and you can use that option. If not, it will return false. So you must ask the return on this method in order to now what to do."
	(self isOptionSupportedByPlattform: DBXSpecialOptions encryption) ifTrue: 
		[ self platform 
			setOption: DBXSpecialOptions encryption
			value: aEncryptionOption
			on: self.
		^ true ].
	^ false! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/12/2008 01:29'!
enableMultipleStatements
"It tries to enable Multiple Statements option. If it can, it activates the option, returns true and you can use that option. If not, it will return false. So you must ask the return on this method in order to now what to do."
	^self enableSpecialOption: DBXSpecialOptions multipleStatements! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/12/2008 01:30'!
enablePagedResults
"It tries to enable paged results. If it can, it activates the option, returns true and you can use that option. If not, it will return false. So you must ask the return on this method in order to now what to do."
	^self enableSpecialOption: DBXSpecialOptions pagedResults.! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/18/2008 16:21'!
enableSpecialModes: modes 
	"It tries to enable specific modes. For example MySQL special modes (http://dev.mysql.com/doc/refman/5.0/en/server-sql-mode.html). If it can, it activates the option, returns true and you can use that option. If not, it will return false. So you must ask the return on this method in order to now what to do."
	(self isOptionSupportedByPlattform: DBXSpecialOptions specialModes) ifTrue: 
		[ self platform 
			setOption: DBXSpecialOptions specialModes
			value: modes
			on: self.
		^ true ].
	^ false! !

!DBXConnection methodsFor: 'private' stamp: 'MMP 8/12/2008 01:34'!
enableSpecialOption: specialOption 
	"It returns if the specialOption could be enable or not.
	Before enabling a specific option, I must be sure the current backend
	support it"
	(self isOptionSupportedByPlattform: specialOption)
		ifTrue: [self platform
				setOption: specialOption
				value: true
				on: self.
				^true.].
		^false.
! !

!DBXConnection methodsFor: 'query' stamp: 'MMP 2/2/2009 20:30'!
execute: aString 
	"This message is used for ALL type of query: SQL, DML and DDL.
	Depending on the type of query it will return DBXResult or
	DBXResultSet. 
	The queries sent to the server must be understood by the DBMS because
	there is no translation done between the different dialects of SQL for
	example. 
	
	To execute a query you must be connected and open.
	
	Some queries return more than one resultSet. This situation will be
	transparent for SqueakDBX user. DBXResultSet #nextRow will
	automatically obtain next resultSet when needed
	
	You DON'T need to call nextRow till nil its returned, the framework will
	do it for you in your next query.
	"
	| aResult |
	self isOpen ifFalse: 
		[ SqueakDBXError signal: 'You cannot execute a query if the connection is not open' ].
	self result ifNotNil: [ self result release ].
	self queryTimeout: nil.
	aResult := self platform 
		executeStatement: aString
		on: self.
	self queryTimeout: nil.
	self result: aResult.
	^ self result! !

!DBXConnection methodsFor: 'query' stamp: 'MMP 2/2/2009 20:30'!
execute: aString querySettings: aQuerySettings 
	"Same as execute, but it ads a page size. Dependent on the native
	database library, it may be possible to retrieve all rows at once (if the
	page size parameter is zero), one by one or more than one row at once.
	All positive values including zero are allowed as values for the page size If
	paging (more than one row at once) is not supported by the backend, it
	will use one by one or all at once if this is the only option provided.
	"
	| aResult |
	self isOpen ifFalse: 
		[ SqueakDBXError signal: 'You cannot execute a query if the connection is not open' ].
	self result ifNotNil: [ self result release ].
	aResult := self platform 
		executeStatement: aString
		on: self
		querySettings: aQuerySettings.
	self result: aResult.
	^ self result! !

!DBXConnection methodsFor: 'query' stamp: 'MMP 12/2/2008 00:00'!
executeDDLScript: aDDLScript 
"Its very common you need to execute a complete DDL script: create, drop or alter tables. In these cases, you don't have any interesting results from each query. In such a case, you should use this method. Remember SqueakDBX doesn't do any translation so your statement delimiter must be understood by the backend. In order to know which delimiter we use, you can see the message queryDelimiter of the current platform backend, for example DBXPostgresPlatform.
This message doesn't use the multistatements option of openDBX, it is all done by SqueakDBX so you don't have to care about it''"

	| ddlStatements |
	ddlStatements := aDDLScript findTokens: self platform queryDelimiter.
	ddlStatements
		do: [:ddlStatement | self execute: ddlStatement]! !

!DBXConnection methodsFor: 'finalization' stamp: 'MMP 8/12/2008 01:18'!
finalize
	" If it is connected, it will disconnect it"
	self isConnected ifTrue: [ self disconnect ]! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 3/30/2008 14:41'!
handle
	^handle! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 5/1/2008 18:37'!
hash
	^ self handle hash! !

!DBXConnection methodsFor: 'initialization' stamp: 'MMP 2/2/2009 20:30'!
initialize
	super initialize.
	"These ValueHolder are very important and you cannot change them. If you instantiate a DBXConnection and never do the disconnect, SqueakDBX will do it whe the object is garbage collected. How SqueakDBX do that? DBXConnection is registered in the default WeakRegistry. So, when you call connect we add the object to that registry. In that moment a clone is generated from the original object. Suppose you then do the disconnect to the original object. If we don't use ValueHolder, the clone will have other objects for open and connected and because of this, the disconnect will be called twice, generating an openDBX error.' "
	open := ValueHolder new contents: false.
	connected := ValueHolder new contents: false.
	result := nil! !

!DBXConnection methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:59'!
initializePlatform: aPlatform settings: aConnectionSettings handle: aNumber
	platform := aPlatform.
	settings := aConnectionSettings.
	handle := aNumber.
	self internalBeConnected.! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeClosed
	open contents: false! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeConnected
	connected contents: true.! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeDisconnected
	connected contents: false.! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeOpen
	open contents: true.! !

!DBXConnection methodsFor: 'testing' stamp: 'MMP 4/25/2008 00:44'!
isConnected
	^connected contents.! !

!DBXConnection methodsFor: 'testing' stamp: 'MMP 4/25/2008 00:44'!
isOpen
	^open contents.! !

!DBXConnection methodsFor: 'private' stamp: 'MMP 8/12/2008 01:32'!
isOptionSupportedByPlattform: specialOption 
"It returns if the specialOption is supported by the backend"
	^self platform
		getOption: specialOption
		on: self.! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 12/22/2008 20:46'!
open
	"Opens the connection. You must first do a connect and you cannot call this method if the connection is already open.. This method will probably opens the tcp/ip database connection. After calling this method, you should be able to send queries"
	self isConnected ifFalse: [
		SqueakDBXError signal: 'You are not connected. Try connecting first'].
	self isOpen ifTrue: [ 
		SqueakDBXError signal: 'The connection is already open'].
	self validateSettingsForOpen.
	self platform openConnection: self.
	self internalBeOpen! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 6/10/2008 01:06'!
platform
	^platform! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 7/1/2008 16:54'!
platform: aPlatform
	platform := aPlatform! !

!DBXConnection methodsFor: 'initialization' stamp: 'MMP 1/26/2009 23:55'!
queryTimeout
"	queryTimeout ifNil: [queryTimeout := DBXTimeSpec seconds: 0 microseconds: 1000.]."
	queryTimeout ifNil: [queryTimeout := DBXTimeSpec seconds: 3.].
	^ queryTimeout! !

!DBXConnection methodsFor: 'initialization' stamp: 'MMP 1/23/2009 00:28'!
queryTimeout: anObject 
	queryTimeout := anObject! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 12/22/2008 20:51'!
reOpen: aConnectionSettings
	"It simply do a close and an open with the new connectionSettings. 
	Suppouse you have a DBXConnection connected and open. Sometimes it may be necessary to connect to a different database (schema) or re-authenticate using different credentials. In such a case you can use this message"
	self isConnected ifFalse: [
		SqueakDBXError signal: 'You are not connected. Try connecting first' ].
	self isOpen ifFalse: [ 
		SqueakDBXError signal: 'The connection must be open in order to reOpen it' ].
	self close.
	self settings: aConnectionSettings.
	self open.! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/29/2008 10:52'!
releaseConnection
	self platform releaseConnection: self! !

!DBXConnection methodsFor: 'private' stamp: 'MMP 2/2/2009 20:31'!
releaseResultSets
	result finalize! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 2/2/2009 19:14'!
result
	^ result! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 2/2/2009 19:14'!
result: anObject 
	result := anObject! !

!DBXConnection methodsFor: 'transactional manage' stamp: 'MMP 2/2/2009 20:31'!
rollback
	"executes a rollback statement"
	| aResult |
	self isOpen ifFalse: 
		[ SqueakDBXError signal: 'You cannot rollback if the connection is not open' ].
	self result ifNotNil: [ self result release ].
	aResult := self platform rollback: self.
	self result: aResult.
	^ self result! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:42'!
settings
	^ settings! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 7/1/2008 16:54'!
settings: aConnectionSettings
	settings := aConnectionSettings! !

!DBXConnection methodsFor: 'running' stamp: 'MMP 10/11/2008 15:30'!
shutDown
	"This message is called when the object is garbage collected. In case the connection was connected, but not disconnected, it will be disconnected"
	 self isConnected ifTrue: [
		 [self disconnect] on: DBXError do: [:e | Transcript show: e ] ]
! !

!DBXConnection methodsFor: 'transactional manage' stamp: 'MMP 2/2/2009 20:32'!
startTransaction
	"executes a start transaction statement"
	| aResult |
	self isOpen ifFalse: 
		[ SqueakDBXError signal: 'You cannot start a transaction if the connection is not open' ].
	self result ifNotNil: [ self result release ].
	aResult := self platform startTransaction: self.
	self result: aResult.
	^ self result! !

!DBXConnection methodsFor: 'running' stamp: 'MMP 8/12/2008 01:54'!
startUp
	"till now, nothing is done on the startup"! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 7/10/2008 23:25'!
validateSettingsForConnect
	self settings validatePort.! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 7/10/2008 23:25'!
validateSettingsForOpen
	self settings method.! !

Object subclass: #DBXConnectionSettings
	instanceVariableNames: 'host port database userName userPassword method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXConnectionSettings class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 09:13'!
host: aHost port: aPort
	^ self basicNew
		initializeHost: aHost 
			port: aPort;
		yourself! !

!DBXConnectionSettings class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 09:31'!
host: aHost port: aPort database: aDatabase userName: aUsername userPassword: aPassword
	^ self basicNew
		initializeHost: aHost 
			port: aPort 
			database: aDatabase 
			userName: aUsername  
			userPassword: aPassword;
		yourself! !

!DBXConnectionSettings class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 09:32'!
host: aDatabase userName: aUsername userPassword: aPassword
	^ self basicNew
		initializeHost: aDatabase 
			userName: aUsername  
			userPassword: aPassword
		yourself! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:07'!
database
	^ database! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
database: anObject
	database := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 6/10/2008 00:50'!
host
	^ host! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
host: anObject
	host := anObject! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:11'!
initializeHost: aHost port: aPort
	self initialize.
	host := aHost.
	port := aPort! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:12'!
initializeHost: aHost port: aPort database: aDatabaseName userName: aUserName userPassword: aPassword
	self initialize.
	host := aHost.
	port := aPort.
	database := aDatabaseName.
	userName := aUserName.
	userPassword := aPassword.! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:13'!
initializeHost: aDatabaseName userName: aUserName userPassword: aPassword
	self initialize.
	database  := aDatabaseName.
	userName := aUserName.
	userPassword := aPassword.! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/11/2008 00:24'!
method
	^ method ifNil: [ method := DBXAuthenticationMethod usernamePassword ]! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
method: anObject
	^ method := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 6/10/2008 00:50'!
port
	^ port! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
port: anObject
	port := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:07'!
userName
	^ userName! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
userName: anObject
	userName := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:07'!
userPassword
	^ userPassword! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
userPassword: anObject
	userPassword := anObject! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'MMP 12/22/2008 20:54'!
validateMethod
	self method notNil ifTrue: 
		[ self method = DBXAuthenticationMethod usernamePassword ifFalse: [ SqueakDBXError signal: 'The only supported method is zero' ] ]! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'HMC 10/15/2008 00:15'!
validatePort
	self flag: #todo. "This validation doesn't work with Pharo... disabling temporaly"
	"self port notNil
		ifTrue: [(self port isPositiveInteger)
			ifFalse: [SqueakDBXError signal: 'The port must be a positive number' transalated]]"! !

Object subclass: #DBXEncryptionValues
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXEncryptionValues class methodsFor: 'as yet unclassified' stamp: 'MMP 8/24/2008 16:58'!
always
	^2! !

!DBXEncryptionValues class methodsFor: 'as yet unclassified' stamp: 'MMP 8/23/2008 21:01'!
never
	^0! !

!DBXEncryptionValues class methodsFor: 'as yet unclassified' stamp: 'MMP 8/23/2008 21:01'!
try
	^1! !

Object subclass: #DBXLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXLogger methodsFor: 'as yet unclassified' stamp: 'MMP 11/25/2008 01:32'!
log
	! !

Object subclass: #DBXPlatform
	instanceVariableNames: ''
	classVariableNames: 'Properties'
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

DBXPlatform class
	instanceVariableNames: 'dataTypesMap'!

!DBXPlatform commentStamp: 'EL 8/16/2008 09:53' prior: 0!
I am the platform abstraction layer. 
I comunicate directly with OpenDBX, and provide a fplatform specific abstraction layer. !

DBXPlatform class
	instanceVariableNames: 'dataTypesMap'!

DBXPlatform subclass: #DBXMSSQLPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXMSSQLPlatform methodsFor: 'as yet unclassified' stamp: 'MMP 11/30/2008 21:10'!
backend
	^'mssql'! !

!DBXMSSQLPlatform methodsFor: 'as yet unclassified' stamp: 'MMP 12/2/2008 00:00'!
queryDelimiter
	^';'! !

!DBXMSSQLPlatform methodsFor: 'as yet unclassified' stamp: 'MMP 12/1/2008 01:31'!
startTransaction
"It returns the start transaction statement most commonly used by the backends"
^'BEGIN TRANSACTION'! !

DBXPlatform subclass: #DBXMySQLPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXMySQLPlatform commentStamp: 'EL 8/16/2008 09:53' prior: 0!
I am the MySQL specific platform definition. 

Instance Variables
	handle:		<Object>

handle
	- xxxxx
!

!DBXMySQLPlatform methodsFor: 'as yet unclassified' stamp: 'EL 6/27/2008 20:30'!
backend
	^'mysql'! !

!DBXMySQLPlatform methodsFor: 'resultSet' stamp: 'MMP 8/11/2008 23:15'!
queryDelimiter
	^';'! !

DBXPlatform subclass: #DBXOdbcPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXOdbcPlatform methodsFor: 'accessing' stamp: 'MMP 11/30/2008 21:30'!
backend
	^'odbc'! !

!DBXOdbcPlatform methodsFor: 'resultSet' stamp: 'MMP 1/4/2009 23:47'!
queryDelimiter
	^';'! !

!DBXOdbcPlatform methodsFor: 'transactional manage' stamp: 'MMP 3/10/2009 02:12'!
startTransaction
"It returns the start transaction statement most commonly used by the backends"
^'START TRANSACTION'! !

DBXPlatform subclass: #DBXOraclePlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXOraclePlatform commentStamp: 'EL 8/16/2008 09:53' prior: 0!
I am the Oracle specific platform definition. 

Instance Variables
	handle:		<Object>

handle
	- xxxxx
!

!DBXOraclePlatform methodsFor: 'accessing' stamp: 'MMP 8/6/2008 01:38'!
backend
	^'oracle'! !

!DBXOraclePlatform methodsFor: 'accessing' stamp: 'MMP 8/11/2008 23:15'!
queryDelimiter
	^';'! !

!DBXOraclePlatform methodsFor: 'accessing' stamp: 'MMP 8/13/2008 03:25'!
startTransaction
	"This is a general approach for starting a transaction. If other approach is wanted, like SET TRANSACTION READ ONLY, you must do it manually like any other query."
	^'SET TRANSACTION READ WRITE'! !

!DBXPlatform class methodsFor: 'defaults' stamp: 'MMP 9/28/2008 21:22'!
createDataTypesMap
	^Dictionary new
		at: 16r00 put: Boolean; "BOOLEAN"
		at: 16r01 put: Number; "SMALLINT"
		at: 16r02 put: Number; "INTEGER"
		at: 16r03 put: Number; "BIGINT"
		at: 16r07 put: Number; "DECIMAL"
		at: 16r08 put: Number; "REAL"
		at: 16r09 put: Number; "DOUBLE"
		at: 16r0F put: Number; "FLOAT"
		at: 16r10 put: String; "CHAR"
		at: 16r11 put: String; "NCHAR"
		at: 16r12 put: String; "VARCHAR"
		at: 16r13 put: String; "NVARCHAR"
		at: 16r20 put: (DBXTypeNotSupported type: #CLOB);
		at: 16r21 put: (DBXTypeNotSupported type: #NCLOB);
		at: 16r22 put: (DBXTypeNotSupported type: #XML);
		at: 16r2F put: (DBXTypeNotSupported type: #BLOB);
		at: 16r30 put: Time; "TIME"
		at: 16r31 put: Time; "TIMETZ"
		at: 16r32 put: TimeStamp; "TIMESTAMP"
		at: 16r33 put: TimeStamp; "TIMESTAMPTZ"
		at: 16r34 put: Date; "DATE"
		at: 16r35 put: (DBXTypeNotSupported type: #INTERVAL);
		at: 16r40 put: (DBXTypeNotSupported type: #ARRAY);
		at: 16r41 put: (DBXTypeNotSupported type: #MULTISET);
		at: 16r50 put: (DBXTypeNotSupported type: #DATALINK);
		at: 16rFF put: (DBXTypeNotSupported type: #UNKNOWN);
		yourself
! !

!DBXPlatform class methodsFor: 'accessing' stamp: 'EL 8/14/2008 09:32'!
dataTypeAt: aNumber
	^self dataTypesMap at: aNumber ifAbsent: [ DBXTypeNotSupported code: aNumber ]! !

!DBXPlatform class methodsFor: 'accessing' stamp: 'MMP 9/25/2008 22:51'!
dataTypesMap
	^dataTypesMap ifNil: [ dataTypesMap := self createDataTypesMap ]! !

!DBXPlatform class methodsFor: 'testing' stamp: 'MMP 9/28/2008 21:13'!
disableDebugMode
	self propertyAt: #debugMode put: false! !

!DBXPlatform class methodsFor: 'testing' stamp: 'MMP 9/28/2008 21:13'!
enableDebugMode
	self propertyAt: #debugMode put: true! !

!DBXPlatform class methodsFor: 'testing' stamp: 'EL 9/14/2008 08:44'!
isDebugMode
	^self propertyAt: #debugMode ifAbsentPut: [ false ]! !

!DBXPlatform class methodsFor: 'testing' stamp: 'EL 8/3/2008 08:53'!
isLarge: aNumber
	"Answer true if aNumber represents a large data object (BLOB, CLOB, NCLOB)"
	^#(16r20 16r21 16r2F) includes: aNumber! !

!DBXPlatform class methodsFor: 'as yet unclassified' stamp: 'MMP 1/5/2009 21:07'!
log: messageBlockOrString
	self isDebugMode ifTrue: [
		Transcript show: messageBlockOrString value; cr.
		    "self log info: messageBlockOrString." ].! !

!DBXPlatform class methodsFor: 'testing' stamp: 'EL 9/14/2008 08:46'!
properties
	^Properties ifNil: [ Properties := Dictionary new ]! !

!DBXPlatform class methodsFor: 'testing' stamp: 'EL 9/14/2008 08:46'!
propertyAt: aSymbol
	^self properties at: aSymbol! !

!DBXPlatform class methodsFor: 'testing' stamp: 'EL 9/14/2008 08:47'!
propertyAt: aSymbol ifAbsent: aBlock
	^self properties at: aSymbol ifAbsent: aBlock! !

!DBXPlatform class methodsFor: 'testing' stamp: 'EL 9/14/2008 08:47'!
propertyAt: aSymbol ifAbsentPut: aBlock
	^self properties at: aSymbol ifAbsentPut: aBlock! !

!DBXPlatform class methodsFor: 'testing' stamp: 'EL 9/14/2008 08:47'!
propertyAt: aSymbol put: anObject
	^self properties at: aSymbol put: anObject! !

!DBXPlatform class methodsFor: 'as yet unclassified' stamp: 'MMP 9/28/2008 21:21'!
reset
	dataTypesMap := nil.! !

!DBXPlatform class methodsFor: 'testing' stamp: 'MMP 9/28/2008 21:13'!
setDebugMode: aBoolean
	self propertyAt: #debugMode put: aBoolean! !

!DBXPlatform methodsFor: 'accessing' stamp: 'MMP 3/1/2009 15:46'!
backend
	"Returns the name of the backend that OpenDBX understands for each RDBMS"
	^self subclassResponsibility! !

!DBXPlatform methodsFor: 'connection' stamp: 'HMC 10/25/2008 19:05'!
closeConnection: aConnection
	"Closes the connection and throws a DBXError if an error occurs"
	| err |
	err := OpenDBX current apiUnbind: aConnection handle.
	self log: [ 'apiUnbind called with values: handle = ', aConnection handle asString ].
	"self verifyError: err on: aConnection."
	self verifyError: err handle: aConnection handle.
! !

!DBXPlatform methodsFor: 'constants' stamp: 'MMP 8/13/2008 03:25'!
commit
	^'COMMIT'! !

!DBXPlatform methodsFor: 'transactional manage' stamp: 'MMP 3/4/2009 01:48'!
commit: aConnection
"executes a commit statement on a connection"
^self executeStatement: self commit on: aConnection.
! !

!DBXPlatform methodsFor: 'connection' stamp: 'MMP 2/4/2009 23:44'!
createConnection: aConnection 
	"It initializes and creates a handle for all further operations, and it is
	used within the OpenDBX library to identify the connection and to
	maintain connection information. Depending on the backend it can open
	a connection to the database server but often this is done not until
	performing authentication through 'openConnection:'
	throws an error if needed"
	| err handleArray handle |
	handleArray := WordArray with: 0.
	err := OpenDBX current
				apiInitialize: handleArray
				backend: self backend
				host: aConnection settings host
				port: aConnection settings port.
	self log: [ 'apiInitialize called with values: backend = ', self backend, ' host = ', aConnection settings host, ' port = ', aConnection settings port asString ].
	handle := handleArray first.
	
	"If it fails here, it means it couldn't connect, so we let the signal pass'"	
	self verifyError: err handle: handle.	
	
	^ handle! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 12/22/2008 20:52'!
dbxSmallIntegerAsBoolean: aSmallInteger 
	aSmallInteger = 1 ifTrue: [ ^ true ].
	aSmallInteger = 0 ifTrue: [ ^ false ].
	SqueakDBXError signal: 'Cannot convert form SmallInteger to Boolean'! !

!DBXPlatform methodsFor: 'private' stamp: 'test 1/8/2009 18:08'!
descriptionForColumn: anIndex handle: aHandle on: aConnection
	"anIndex is Zero based"
	| columnName dbxType |
	columnName := OpenDBX current apiQueryColumnName: aHandle index: anIndex.
	"self log: 'apiQueryColumnName called with values: handle = ', aHandle asString, ' index = ', anIndex asString."
	dbxType := OpenDBX current apiQueryColumnType: aHandle index: anIndex. 
	"self log: 'apiQueryColumnType called with values: handle = ', aHandle asString, ' index = ', anIndex asString."
	^DBXColumnDescription 
		name: columnName
		dbxType: dbxType
		type: (self class dataTypeAt: dbxType).! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 9/21/2008 19:37'!
descriptionForResult: aHandle on: aConnection
	| rowsAffected |
	rowsAffected := OpenDBX current apiQueryRowsAffected: aHandle.
	self log: [ 'apiQueryRowsAffected: called with values: handle = ', aHandle asString ].
	self  verifyError: rowsAffected on: aConnection. 
	^DBXResultDescription new
		rowsAffected: rowsAffected;
		yourself.
! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 2/5/2009 00:11'!
descriptionForResultSet: aHandle on: aConnection 
	| description columnCount |
	columnCount := OpenDBX current apiQueryColumns: aHandle.
	self log: [ 'apiQueryColumns: called with values: handle = ', aHandle asString ].
	self verifyError: columnCount on: aConnection.
	description := DBXResultSetDescription new.
	0 to: columnCount - 1
		do: [:i | description
				addColumnDescription: (self
						descriptionForColumn: i
						handle: aHandle
						on: aConnection)].
	^ description! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 1/31/2009 20:34'!
endDBXResult: aConnection querySettings: aQuerySettings
	| err  resultCode |	
	[self
		nextResultSet: aConnection
		querySettings:  aQuerySettings
		onReturn: [:handle :code | 
			code = OpenDBX resultWithRows
				ifTrue: [
					err := OpenDBX current apiQueryFinalize: handle.
					self log: ['apiQueryFinalize: called with values: handle = ', handle asString.
					self verifyError: err on: aConnection. ] ].
			resultCode := code]]
	doWhileFalse: [resultCode = OpenDBX resultDone].
	
! !

!DBXPlatform methodsFor: 'private' stamp: 'HMC 10/25/2008 18:50'!
errorCode: err handle: aHandle 
	| type description |
	description := OpenDBX current apiError: aHandle number: err.
	type := OpenDBX current apiErrorType: aHandle number: err.
	type < 0
		ifTrue: ["It's fatal!!"
			DBXFatalError signal: description].
	DBXRecoverableError signal: description! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 2/2/2009 20:58'!
errorCode: err on: aConnection 
	| type description |
	description := OpenDBX current apiError: aConnection handle number: err.
	type := OpenDBX current apiErrorType: aConnection handle number: err.
	type < 0
		ifTrue: ["It's fatal!!"
			aConnection close.
			aConnection disconnect.
			DBXFatalError signal: description].
		
		aConnection result ifNil: [
			self endDBXResult: aConnection querySettings: DBXQuerySettings default .
		] ifNotNil: [
			self endDBXResult: aConnection querySettings: aConnection result querySettings .
		].
		
	 description ifNil: [ description := 'Uknown message' ].
	DBXRecoverableError signal: description! !

!DBXPlatform methodsFor: 'connection' stamp: 'MMP 1/31/2009 20:30'!
executeStatement: aQuery on: aConnection 
	"It executes the query using the connection and retrieve al rows at once (no pagination is used). 
	
There are some important things:

    * this method returns a DBXResultSet if it was a select statement and a DBXResult in case the query was an update, delete, insert, create, drop or any other DML query.
    * The queries sent to the server must be understood by the DBMS because there is no translation done between the different dialects of SQL for example. But this is desired!! It adds no further level of complexity to the library and your program which slows down your real work. Usually only a few statements with varying values are used in programs and the easiest way make them adaptable to different databases by the users is to get them from a configuration file, strategy pattern or whatever. "

	^self executeStatement: aQuery on: aConnection querySettings: DBXQuerySettings default.
! !

!DBXPlatform methodsFor: 'connection' stamp: 'MMP 2/2/2009 20:15'!
executeStatement: aString on: aConnection querySettings: aQuerySettings 
	"After executing a query, we will then want to retrieve the results. It may be possible to retrieve all rows at once, one by one or more than one row at once. All positive values including zero are allowed as values for a page size. As this is a special option that not all the engines support you must enable this feature using DBXConnection #enablePagedResults. If paging (more than one row at once) is not supported by the backend, it will use 'one by one' or 'all at once' if this is the only option provided."
	| err description err2 returnCode|
	err := OpenDBX current
				apiQuery: aConnection handle
				query: aString
				length: aString size.
	self log: 'apiQuery: called with values: handle = ', aConnection handle asString, ' query = ', aString.
	self verifyError: err on: aConnection.
	
	[self
		nextResultSet: aConnection
		querySettings: aQuerySettings
		onReturn: [:handle :code | 
			returnCode := code.
			code = OpenDBX resultWithoutRows
				ifTrue: [description := self descriptionForResult: handle on: aConnection.
					err2 := OpenDBX current apiQueryFinalize: handle.
					self log: [ 'apiQueryFinalize: called with values: handle = ', handle asString ].			
					self endDBXResult: aConnection querySettings: aQuerySettings.
					^ DBXResult
						on: aConnection
						handle: handle
						description: description
						querySettings: aQuerySettings].
			code = OpenDBX resultWithRows
				ifTrue: [description := self descriptionForResultSet: handle on: aConnection.
					^ DBXResultSet
						on: aConnection
						handle: handle
						description: description
						querySettings: aQuerySettings ].
	
			]] 	doWhileTrue: [returnCode = OpenDBX resultTimeout].
		
		SqueakDBXError signal: 'Uknown problem with executeStatement'.! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'HMC 8/18/2008 12:21'!
fieldRawValue: anIndex on: aResultSet
	^OpenDBX current apiQueryFieldValue: (aResultSet handle) index: (anIndex - 1)! !

!DBXPlatform methodsFor: 'options' stamp: 'MMP 2/4/2009 23:44'!
getOption: anOption on: aConnection 
	"It asks the backend if an specific option is supported or not"
	| err isSupported |
	isSupported := WordArray with: 0.
	err := OpenDBX current 
		apiGetOption: aConnection handle
		option: anOption
		value: isSupported.
	self 
		verifyError: err
		on: aConnection.
	^ self dbxSmallIntegerAsBoolean: (isSupported first)! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'EL 8/6/2008 08:57'!
largeFieldRawValue: anIndex on: aResultSet
	OpenDBX current apiQueryFieldValue: (aResultSet handle) index: (anIndex - 1)! !

!DBXPlatform methodsFor: 'accessing' stamp: 'EL 9/14/2008 08:49'!
log: messageBlockOrString
	self class log: messageBlockOrString! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 9/14/2008 23:23'!
moveNext: aResultSet 
	| err |
	err := OpenDBX current apiQueryFetchRow: aResultSet handle.
	self log: ['apiQueryFetchRow: called with values: handle = ', aResultSet handle asString].
	self verifyError: err on: aResultSet connection.
	err = OpenDBX rowDone
		ifTrue: [(self restartResultSet: aResultSet)
				ifTrue: [^ self moveNext: aResultSet]
				ifFalse: [^ nil]]
		ifFalse: [^ DBXRow on: aResultSet]! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 1/31/2009 20:41'!
nextResultSet: aResultSet ifDone: aBlock 
	^ self
		nextResultSet: aResultSet connection
		querySettings: aResultSet querySettings
		onReturn: [:handle :code | code = OpenDBX resultDone
				ifTrue: [aBlock value]]! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 2/4/2009 23:43'!
nextResultSet: aConnection querySettings: aQuerySettings onReturn: aBlock 
	| handle err handleArray |
	handleArray := WordArray with: 0.

	err := OpenDBX current
				apiQueryResult: aConnection handle
				handle: handleArray
				timeout: aQuerySettings queryTimeout
				chunk: aQuerySettings pageSize.
	self log: [
		'apiQueryResult: called with values:',
			' handle = ', aConnection handle asString, 
			' chunk = ', aQuerySettings pageSize asString,
			String cr, 
		'apiQueryResult call return: ', err asString ].
	
	self verifyError: err on: aConnection.
	
	handle := handleArray first.
	aBlock notNil
		ifTrue: [aBlock value: handle value: err].
	^ handle! !

!DBXPlatform methodsFor: 'connection' stamp: 'MMP 2/4/2009 23:03'!
openConnection: aConnection 
	"'createConnection: should be called first'"
	"It opens the connection, by associating the handle created by
	'createConnection:' to a specific database after the server verified and
	accepted the user credentials. All further operations will (normally)
	only affect the tables and records within this database. The operations
	may be limited to certain subset depending on the privileges granted to
	the given user account. If 'openConnection:' succeeds, it also enables
	compatibility to the ANSI SQL standard if this is possible for the database
	server implementation."
	| err |
	err := OpenDBX current
				apiBind: aConnection handle
				database: aConnection settings database
				name: aConnection settings userName
				password: aConnection settings userPassword
				method: aConnection settings method.
	self log: [ 'apiBind: called with values:',
				' handle = ', aConnection handle asString, 
				' database = ', aConnection settings database, 
				' userName = ', 	aConnection settings userName, 
				' userPassword = ', aConnection settings userPassword ].

	"If it's a fatal error, it means it couldn't open the connection, therefore, we just unbind it and signal the error again"
		[self verifyError: err handle: aConnection handle]
		on: DBXFatalError
		do: [:e | 
		self releaseConnectionHandle: aConnection handle.
		e signal].	
	
	^ true! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 8/11/2008 23:14'!
queryDelimiter
	^self subclassResponsibility! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 1/31/2009 20:43'!
releaseAllQueryResultSets: aResultSet 
	"Releases all query resultsSets a query may return by iterating them.
	Each resultSet is Closed and all allocated memory by the OpenDBX
	library is freed ."
	| err |
	err := OpenDBX current apiQueryFinalize: aResultSet handle.
	self log: [ 'apiQueryFinalize: called with values: handle = ', aResultSet handle asString ].
	self verifyError: err on: aResultSet connection.
	self endDBXResult: aResultSet connection querySettings: aResultSet querySettings! !

!DBXPlatform methodsFor: 'connection' stamp: 'HMC 10/25/2008 19:09'!
releaseConnection: aConnection
	"It releases all the resources associated with a connection"
	| err |
	err := OpenDBX current apiFinalize: aConnection handle.
	self log: [ 'apiFinalize: called with values: handle = ', aConnection handle asString ].
	"self  verifyError: err on: aConnection."
	"Si el error es fatal aca, ya no hago nada, lo informo"
	self verifyError: err handle: aConnection handle.! !

!DBXPlatform methodsFor: 'private' stamp: 'HMC 10/21/2008 16:44'!
releaseConnectionHandle: aHandle
	"It releases all the resources associated with a connection"
	| err |
	err := OpenDBX current apiFinalize: aHandle .
	self log: [ 'apiFinalize: called with values: handle = ', aHandle  asString ].
	self  verifyError: err handle: aHandle.
! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'EL 9/14/2008 08:40'!
releaseResultSet: aResultSet 
	"Closes a resultSet and all allocated memory by the OpenDBX library is
	freed . In case you want to realese all query resultSets, yo must call
	realeseAllQueryResultSets: "
	| err |
	err := OpenDBX current apiQueryFinalize: aResultSet handle.
	self log: [ 'apiQueryFinalize: called with values: handle = ', aResultSet handle asString ].
	self verifyError: err on: aResultSet connection! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 8/18/2008 01:27'!
restartResultSet: aResultSet 
	| newResultSetHandle |
	self releaseResultSet: aResultSet.
	newResultSetHandle := self
				nextResultSet: aResultSet
				ifDone: [^ false].
	aResultSet handle: newResultSetHandle.
	"When I restart a resultSet is possible it changes the description, like the
	column count. For example, in multiple statements."
	aResultSet
		description: (self descriptionForResultSet: aResultSet handle on: aResultSet connection).
	^ true
! !

!DBXPlatform methodsFor: 'constants' stamp: 'HMC 8/12/2008 13:38'!
rollback
^'ROLLBACK'! !

!DBXPlatform methodsFor: 'transactional manage' stamp: 'HMC 8/18/2008 12:33'!
rollback: aConnection
"executes a rollback statement on a connection"
^self executeStatement: self rollback on: aConnection.! !

!DBXPlatform methodsFor: 'options' stamp: 'MMP 2/3/2009 01:25'!
setOption: anOption value: anObject on: aConnection 
	"It enables an specific option for a connection."
	| err value |
	(anObject class = True) ifTrue: [value := ByteArray with: anObject asBit ].
	(anObject class = False) ifTrue: [value := ByteArray with: anObject asBit ].
	(anObject class = SmallInteger) ifTrue: [value := ByteArray with: anObject].
	(anObject class = ByteString) ifTrue: [value := anObject ].
	err := OpenDBX current
				apiSetOption: aConnection handle
				option: anOption
				value: value.
	self verifyError: err on: aConnection! !

!DBXPlatform methodsFor: 'transactional manage' stamp: 'HMC 8/18/2008 12:34'!
startTransaction
"It returns the start transaction statement most commonly used by the backends"
^'START TRANSACTION'! !

!DBXPlatform methodsFor: 'transactional manage' stamp: 'HMC 8/18/2008 12:34'!
startTransaction: aConnection
"Starts a transaction on a connection"
^self executeStatement: self startTransaction on: aConnection.! !

!DBXPlatform methodsFor: 'error handling' stamp: 'MMP 8/16/2008 23:07'!
verifyError: err handle: aHandle
	"If verifies if a returned number of a call to an openDBX function, is an error or not. If true, a DBXError is thrown with the associated openDBX message for that error."
	(err < 0) ifTrue: [ self errorCode: err handle: aHandle]! !

!DBXPlatform methodsFor: 'error handling' stamp: 'HMC 10/25/2008 18:34'!
verifyError: err on: aConnection 
	"It verifies if a returned number of a call to an OpenDBX function, is an
	error or not. If true, a DBXError is thrown with the associated OpenDBX
	message for that error."
	err < 0
		ifTrue: [self errorCode: err on: aConnection]! !

DBXPlatform subclass: #DBXPostgresPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXPostgresPlatform commentStamp: 'EL 8/16/2008 09:53' prior: 0!
I am the PostgreSQL specific platform definition. 

Instance Variables
!

!DBXPostgresPlatform methodsFor: 'as yet unclassified' stamp: 'EL 6/27/2008 20:30'!
backend
	^'pgsql'! !

!DBXPostgresPlatform methodsFor: 'accessing' stamp: 'MMP 8/11/2008 23:15'!
queryDelimiter
	^';'! !

DBXPlatform subclass: #DBXSqlitePlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXSqlitePlatform class methodsFor: 'defaults' stamp: 'MMP 9/25/2008 22:56'!
createDataTypesMap
	^super createDataTypesMap
		at: 16r20 put: String; "CLOB"
		yourself! !

!DBXSqlitePlatform methodsFor: 'accessing' stamp: 'MMP 9/9/2008 01:39'!
backend
	^'sqlite3'! !

!DBXSqlitePlatform methodsFor: 'resultSet' stamp: 'MMP 9/17/2008 23:28'!
queryDelimiter
	^';'! !

!DBXSqlitePlatform methodsFor: 'transactional manage' stamp: 'MMP 9/16/2008 01:22'!
startTransaction
	^'BEGIN TRANSACTION'! !

Object subclass: #DBXQuerySettings
	instanceVariableNames: 'pageSize queryTimeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXQuerySettings class methodsFor: 'as yet unclassified' stamp: 'MMP 1/31/2009 20:29'!
default
	^ self pageSize: self defaultPageSize timeout: self defaultTimeout 
! !

!DBXQuerySettings class methodsFor: 'as yet unclassified' stamp: 'MMP 1/31/2009 20:30'!
defaultPageSize
	^ 0! !

!DBXQuerySettings class methodsFor: 'as yet unclassified' stamp: 'MMP 1/31/2009 20:30'!
defaultTimeout
	^nil! !

!DBXQuerySettings class methodsFor: 'as yet unclassified' stamp: 'MMP 1/31/2009 20:09'!
pageSize: aPageSize timeout: aTimeout 
	^(super new)
		pageSize: aPageSize;
		queryTimeout: aTimeout;
		yourself.! !

!DBXQuerySettings methodsFor: 'accessing' stamp: 'MMP 1/31/2009 20:03'!
pageSize
	^ pageSize! !

!DBXQuerySettings methodsFor: 'accessing' stamp: 'MMP 1/31/2009 20:03'!
pageSize: anObject
	pageSize := anObject! !

!DBXQuerySettings methodsFor: 'accessing' stamp: 'MMP 1/31/2009 20:03'!
queryTimeout
	^ queryTimeout! !

!DBXQuerySettings methodsFor: 'accessing' stamp: 'MMP 1/31/2009 20:03'!
queryTimeout: anObject
	queryTimeout := anObject! !

Object subclass: #DBXResultDescription
	instanceVariableNames: 'rowsAffected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Description'!

!DBXResultDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:02'!
rowsAffected
"number of rows that have been changed by the current statement"
	^rowsAffected! !

!DBXResultDescription methodsFor: 'accessing' stamp: 'EL 6/29/2008 12:52'!
rowsAffected: aNumber
	rowsAffected := aNumber ! !

Object subclass: #DBXResultSetDescription
	instanceVariableNames: 'columnDescriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Description'!

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:09'!
addColumnDescription: aColumnDescription
"it adds a new column description to the column descriptions collection"
	self columnDescriptions add: aColumnDescription! !

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:10'!
columnCount
"this allows you to know the number of columns for each row retrieved from the database"
	^self columnDescriptions size! !

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:11'!
columnDescriptionAt: anIndex
"returns the column description holded in 'anIndex' position"
	^self columnDescriptions at: anIndex! !

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:12'!
columnDescriptions
"Collection of column descriptions"
	^columnDescriptions ! !

!DBXResultSetDescription methodsFor: 'initialization' stamp: 'HMC 8/16/2008 21:09'!
initialize
"this DBXResultSetDescription will contain a collection of its own column descriptions, retrieved from the database"
	super initialize.
	columnDescriptions := OrderedCollection new.! !

Object subclass: #DBXRow
	instanceVariableNames: 'resultSet rawValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXRow class methodsFor: 'instance creation' stamp: 'EL 3/31/2008 10:21'!
new
	self error: 'Use #onResultSet:'! !

!DBXRow class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 11:27'!
on: aResultSet
	^(self basicNew)
		initializeResultSet: aResultSet;
		yourself.
		! !

!DBXRow methodsFor: 'private' stamp: 'EL 6/27/2008 22:01'!
columnDescriptionAt: anIndex
	^self resultSet columnDescriptionAt: anIndex! !

!DBXRow methodsFor: 'private' stamp: 'EL 6/27/2008 21:59'!
columnDescriptionType: anIndex
	^(self columnDescriptionAt: anIndex) type! !

!DBXRow methodsFor: 'private' stamp: 'MMP 8/23/2008 18:27'!
columnDescriptionWithName: columnName
	^self resultSet columnDescriptionWithName: columnName


 ! !

!DBXRow methodsFor: 'private' stamp: 'MMP 12/22/2008 20:55'!
columnIndex: aString 
	self resultSet columnDescriptions
		withIndexDo: [:each :index | (each name sameAs: aString)
				ifTrue: [^ index]].
	SqueakDBXError signal: 'A column with that name was not found'.
! !

!DBXRow methodsFor: 'private' stamp: 'EL 8/19/2008 13:38'!
convertValueAt: anIndex 
	^ (self rawValueAt: anIndex)
		ifNotNilDo: [:columnValue | (self columnDescriptionType: anIndex)
			fromDbxString: columnValue]! !

!DBXRow methodsFor: 'initialization' stamp: 'MMP 8/16/2008 21:15'!
initializeResultSet: aResultSet
	"It initialize a Row receiving a result set. We need the result set in order to ask the information about the column descriptions"
	super initialize.
	resultSet := aResultSet.
	self initializeRow.
	! !

!DBXRow methodsFor: 'initialization' stamp: 'MMP 12/22/2008 20:55'!
initializeRow
	"Initialize the row. All the row values will be set."
	rawValues := Array new: self resultSet columnCount.
	self resultSet columnDescriptions withIndexDo: [ :each :i|
		each isLarge
			ifTrue: [ SqueakDBXError signal: 'Large objects not supported yet' ]
			ifFalse: [ rawValues at: i put: (self platform fieldRawValue: i  on: self resultSet) ] ]! !

!DBXRow methodsFor: 'private' stamp: 'EL 6/29/2008 12:19'!
platform
	^self resultSet platform! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:06'!
rawValueAt: anIndex
	"It returns the value of the raw at the specified index. No conversion is here, so all values will be String"
	^rawValues at: anIndex! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:07'!
rawValueNamed: aString
	"It returns the value of the raw with the specified name. No conversion is here, so all values will be String"
	^self rawValueAt: (self columnIndex: aString) ! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:07'!
rawValues
	"It returns the values of all the raw. No conversion is here, so all values will be String"
	^rawValues! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:09'!
rawValuesDo: aBlock
	"It will execute the block on all the row values. No conversion is here, so all values will be String"
	^self rawValues do: aBlock! !

!DBXRow methodsFor: 'accessing' stamp: 'EL 3/31/2008 10:22'!
resultSet
	^ resultSet! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:11'!
valueAt: anIndex
	"It returns the value of the raw at the specified index. Each string returned from openDBX will be converted, if supported, to Squeak types"
	^self convertValueAt: anIndex 
! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:11'!
valueNamed: aString
	"It returns the value of the raw with the specified name. Each string returned from openDBX will be converted, if supported, to Squeak types"
	^self convertValueAt: (self columnIndex: aString).
! !

!DBXRow methodsFor: 'accessing' stamp: 'test 1/8/2009 18:08'!
values
	"It returns the all the values of the raw. Each string returned from openDBX will be converted, if supported, to Squeak types"
	^self rawValues withIndexCollect: [ :each :index | 
		each ifNotNil: [
			(self columnDescriptionType: index) fromDbxString: each ] ]! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:12'!
valuesDo: aBlock
	"It will execute the block on all the row values. Each string returned from openDBX will be converted, if supported, to Squeak types"
	^self values do: aBlock! !

Object subclass: #DBXSpecialOptions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
compression
	"0x0022 in hexadecimal in openDBX. But we need it as decimal"
	^16r0022! !

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
encryption
	 "0x0010 in hexadecimal in openDBX. But we need it as decimal"
	^16r0010! !

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
multipleStatements
	 "0x0020 in hexadecimal in openDBX. But we need it as decimal"
	^16r0020! !

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
pagedResults
 	"0x0021 in hexadecimal in openDBX. But we need it as decimal"
	^16r0021! !

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 8/18/2008 16:19'!
specialModes
	"0x0023 in hexadecimal in openDBX. But we need it as decimal"
	^16r0023
! !

Object subclass: #DBXTranscript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXTranscript class methodsFor: 'stream extensions' stamp: 'MMP 9/14/2008 23:23'!
show: result
	result class = DBXResult
		ifTrue: [self showResult: result].
	result class = DBXResultSet
		ifTrue: [self showResultSet: result]! !

!DBXTranscript class methodsFor: 'stream extensions' stamp: 'MMP 7/18/2008 22:25'!
showResult: result 
	Transcript show: 'They were affected ' , result rowsAffected asString, ' rows';
		 cr! !

!DBXTranscript class methodsFor: 'stream extensions' stamp: 'MMP 9/14/2008 23:18'!
showResultSet: resultSet 
	| stream |
	stream := String new writeStream.
	resultSet columnDescriptions
		do: [:each | stream nextPutAll: each name]
		separatedBy: [stream nextPutAll: ' | '].
	Transcript show: stream contents;
		 cr.
	resultSet
		rowsDo: [:row | 
			stream := String new writeStream.
			row values
				do: [:each | stream nextPutAll: each asString]
				separatedBy: [stream nextPutAll: ' | '].
			Transcript show: stream contents;
				 cr]! !

Object subclass: #DBXTypeNotSupported
	instanceVariableNames: 'code type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXTypeNotSupported commentStamp: 'EL 8/3/2008 08:33' prior: 0!
I'm an unsupported data type

Instance Variables
!

!DBXTypeNotSupported class methodsFor: 'instance creation' stamp: 'EL 8/14/2008 09:33'!
code: aNumber
	^self new
		code: aNumber;
		yourself! !

!DBXTypeNotSupported class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/5/2008 08:45'!
fromDbxString: aString
	self error: 'Type not supported'! !

!DBXTypeNotSupported class methodsFor: 'instance creation' stamp: 'EL 8/14/2008 09:33'!
type: aSymbol
	^self new
		type: aSymbol;
		yourself! !

!DBXTypeNotSupported methodsFor: 'accessing' stamp: 'EL 8/14/2008 09:32'!
code
	^ code! !

!DBXTypeNotSupported methodsFor: 'accessing' stamp: 'EL 8/14/2008 09:32'!
code: anObject
	code := anObject! !

!DBXTypeNotSupported methodsFor: 'dbx' stamp: 'MMP 12/22/2008 20:56'!
fromDbxString: aString
	self type 
		ifNotNil: [ SqueakDBXError signal: ('Unsupported data type: {1}, trying to parse: {2}' format: {self type. aString}) ]
		ifNil: [ SqueakDBXError signal: ('Unknown data type: {1}, trying to parse: {2}' format: {self code. aString}) ]
		
	
! !

!DBXTypeNotSupported methodsFor: 'accessing' stamp: 'EL 8/14/2008 09:32'!
type
	^ type! !

!DBXTypeNotSupported methodsFor: 'accessing' stamp: 'EL 8/14/2008 09:32'!
type: anObject
	type := anObject! !

!Object class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:09'!
fromDbxString: aString
	self subclassResponsibility! !

!Object methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:18'!
asDbxString
	^ self printString! !

Object subclass: #OpenDBX
	instanceVariableNames: ''
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!OpenDBX class methodsFor: 'instance creation' stamp: 'EL 8/6/2008 08:54'!
current
	^Current ifNil: [ Current := self new ]! !

!OpenDBX class methodsFor: 'instance creation' stamp: 'EL 9/11/2008 12:17'!
current: anObject
	^Current := anObject! !

!OpenDBX class methodsFor: 'constants' stamp: 'MMP 8/10/2008 17:26'!
currentOpenDBXVersion
	^'1.3.10'! !

!OpenDBX class methodsFor: 'instance creation' stamp: 'EL 8/6/2008 09:43'!
new
	SmalltalkImage current platformName = 'Win32' ifTrue:[ ^OpenDBXWin32 basicNew initialize].
	SmalltalkImage current platformName = 'unix' ifTrue:[ ^OpenDBXUnix basicNew initialize].
	SmalltalkImage current platformName = 'Mac OS' ifTrue:[ ^OpenDBXMacOSX basicNew initialize].
	self error: 'Cannot identify platform'.
! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 11:19'!
resultDone
	"ODBX_RES_DONE"
	^0! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 13:20'!
resultTimeout
	^1! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 13:21'!
resultWithRows
	^3! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 13:20'!
resultWithoutRows
	^2! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/28/2008 09:11'!
rowDone
	"ODBX_ROW_DONE"
	^0! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/28/2008 09:10'!
rowNext
	"ODBX_ROW_NEXT"
	^1! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiBind: handle database: databaseName name: userName password: password method: method
	"int odbx_bind(odbx_t* handle, const char* database, const char* who, const char* cred,int method )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiError: handle number: err
	"long odbx_error(odbx_t*)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'as yet unclassified' stamp: 'HMC 10/11/2008 10:41'!
apiErrorType: handle number: err 
	"int odbx_error_type( odbx_t* , int error )"
	^ self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiFinalize: handle 
	"long odbx_finish(odbx_t*)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiGetOption: handle option: anOption value: aValue
	"int odbx_get_option(odbx_t* handle, unsigned int option,void* value)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiInitialize: handle backend: backend host: host port: port
	"long odbx_init(odbx_t**, char*, char*, char*)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiOpenLarge: aResultSetHandleNumber handle: aLargeHandleWordArray value: aString
	"int odbx_lo_open(odbx_result_t* result, odbx_lo_t** lo, const char* value)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQuery: handle query: query length: length
	"long odbx_query(odbx_t*, char*, ulong)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryColumnLength: handle index: index
	"unsigned long odbx_field_length( odbx_result_t* result, unsigned long pos ) "
	"IMPORTANT: Index es zero-based"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryColumnName: handle index: index
	"char* odbx_column_name(odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryColumnType: handle index: index
	"char* odbx_column_type( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryColumns: handle
	"int odbx_column_count(odbx_result_t* result )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryFetchRow: handle 
	"int odbx_row_fetch( odbx_result_t* result )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryFieldValue: handle index: index
	"const char* odbx_field_value( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryFinalize: handle
	"int odbx_result_finish( odbx_result_t* result )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:49'!
apiQueryResult: connectionHandle handle: handle timeout: timeout chunk: chunk
	"int odbx_result( odbx_t* handle, odbx_result_t** result, struct timeval* timeout, unsigned long chunk )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:49'!
apiQueryRowsAffected: handle
	"uint64_t odbx_rows_affected(odbx_result_t* result )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:49'!
apiSetOption: handle option: anOption value: aValue
	"int odbx_set_option(odbx_t* handle, unsigned int option, void* value ) "
	^self subclassResponsibility	
! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:49'!
apiUnbind: handle 
	"int odbx_unbind(odbx_t*)"
	^self subclassResponsibility! !

OpenDBX subclass: #OpenDBXUnix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

OpenDBXUnix subclass: #OpenDBXMacOSX
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!OpenDBXUnix methodsFor: 'api calls' stamp: 'MMP 9/13/2008 17:18'!
apiBind: handle database: databaseName name: userName password: password method: method
	"int odbx_bind(odbx_t* handle, const char* database, const char* who, const char* cred,int method )"
	<cdecl: long 'odbx_bind' (ulong char* char* char* ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'HMC 10/11/2008 10:42'!
apiError: handle number: err
	"long odbx_error(odbx_t*, int)"
	<cdecl: char* 'odbx_error' (ulong long) module: 'opendbx' >
	^self externalCallFailed	! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'HMC 10/11/2008 12:17'!
apiErrorType: handle number: err 
	"int odbx_error_type( odbx_t*, int )"
	<cdecl: long 'odbx_error_type' (ulong long) module: 'opendbx'>
	^ self externalCallFailed! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:44'!
apiFinalize: handle 
	"long odbx_finish(odbx_t*)"
	<cdecl: long 'odbx_finish' (ulong) module: 'opendbx' >
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:44'!
apiGetOption: handle option: anOption value: aValue
	"int odbx_get_option(odbx_t* handle, unsigned int option,void* value)"
	<cdecl: long 'odbx_get_option' (ulong ulong void*) module: 'opendbx' >
	^self externalCallFailed
	
! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:45'!
apiInitialize: handle backend: backend host: host port: port
	"long odbx_init(odbx_t**, char*, char*, char*)"
	<cdecl: long 'odbx_init' (ulong* char* char* char*) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:45'!
apiOpenLarge: aResultSetHandleNumber handle: aLargeHandleWordArray value: aString
	"int odbx_lo_open(odbx_result_t* result, odbx_lo_t** lo, const char* value)"
	<cdecl: long 'odbx_lo_open' (ulong ulong* char*) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:45'!
apiQuery: handle query: query length: length
	"long odbx_query(odbx_t*, char*, ulong)"
	<cdecl: long 'odbx_query' (ulong char* ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:45'!
apiQueryColumnLength: handle index: index
	"unsigned long odbx_field_length( odbx_result_t* result, unsigned long pos ) "
	"IMPORTANT: Index es zero-based"
	<cdecl: long 'odbx_field_length' (ulong ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:45'!
apiQueryColumnName: handle index: index
	"char* odbx_column_name(odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	<cdecl: char* 'odbx_column_name' (ulong short) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:45'!
apiQueryColumnType: handle index: index
	"char* odbx_column_type( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	<cdecl: short 'odbx_column_type' (ulong short) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:46'!
apiQueryColumns: handle
	"int odbx_column_count(odbx_result_t* result )"
	<cdecl: long 'odbx_column_count' (ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:46'!
apiQueryFetchRow: handle 
	"int odbx_row_fetch( odbx_result_t* result )"
	<cdecl: long 'odbx_row_fetch' (ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:33'!
apiQueryFieldValue: handle index: index
	"const char* odbx_field_value( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	<cdecl: char* 'odbx_field_value' (ulong ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:46'!
apiQueryFinalize: handle
	"int odbx_result_finish( odbx_result_t* result )"
	<cdecl: long 'odbx_result_finish' (ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'MMP 9/25/2008 20:59'!
apiQueryResult: connectionHandle handle: handle timeout: timeout chunk: chunk
	"int odbx_result( odbx_t* handle, odbx_result_t** result, struct timeval* timeout, unsigned long chunk )"
	<cdecl: long 'odbx_result' (ulong ulong* DBXTimeSpec* ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:46'!
apiQueryRowsAffected: handle
	"uint64_t odbx_rows_affected(odbx_result_t* result )"
	<cdecl: long 'odbx_rows_affected' (ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'MMP 8/24/2008 23:50'!
apiSetOption: handle option: anOption value: aValue
	"int odbx_set_option(odbx_t* handle, unsigned int option, void* value ) "
	<cdecl: long 'odbx_set_option' (ulong ulong char*) module: 'opendbx' >
	^self externalCallFailed
	
! !

!OpenDBXUnix methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiUnbind: handle 
	"int odbx_unbind(odbx_t*)"
	<cdecl: long 'odbx_unbind' (ulong) module: 'opendbx' >
	^self externalCallFailed! !

OpenDBX subclass: #OpenDBXWin32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:39'!
apiBind: handle database: databaseName name: userName password: password method: method
	"int odbx_bind(odbx_t* handle, const char* database, const char* who, const char* cred,int method )"
	<apicall: long 'odbx_bind' (ulong char* char* char* ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:39'!
apiError: handle number: err
	"long odbx_error(odbx_t*)"
	<apicall: char* 'odbx_error' (ulong long) module: 'libopendbx-1.dll' >
	^self externalCallFailed	! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'HMC 10/11/2008 12:17'!
apiErrorType: handle number: err 
	"int odbx_error_type( odbx_t*, int )"
	<apicall: long 'odbx_error_type' (ulong long) module: 'libopendbx-1.dll'>
	^ self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:39'!
apiFinalize: handle 
	"long odbx_finish(odbx_t*)"
	<apicall: long 'odbx_finish' (ulong) module: 'libopendbx-1.dll' >
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:40'!
apiGetOption: handle option: anOption value: aValue
	"int odbx_get_option(odbx_t* handle, unsigned int option,void* value)"
	<apicall: long 'odbx_get_option' (ulong ulong void*) module: 'libopendbx-1.dll' >
	^self externalCallFailed
	
! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:40'!
apiInitialize: handle backend: backend host: host port: port
	"long odbx_init(odbx_t**, char*, char*, char*)"
	<apicall: long 'odbx_init' (ulong* char* char* char*) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:41'!
apiOpenLarge: aResultSetHandleNumber handle: aLargeHandleWordArray value: aString
	"int odbx_lo_open(odbx_result_t* result, odbx_lo_t** lo, const char* value)"
	<apicall: long 'odbx_lo_open' (ulong ulong* char*) module: 'libopendbx-1.dll' >
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:41'!
apiQuery: handle query: query length: length
	"long odbx_query(odbx_t*, char*, ulong)"
	<apicall: long 'odbx_query' (ulong char* ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:41'!
apiQueryColumnLength: handle index: index
	"unsigned long odbx_field_length( odbx_result_t* result, unsigned long pos ) "
	"IMPORTANT: Index es zero-based"
	<apicall: long 'odbx_field_length' (ulong ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:42'!
apiQueryColumnName: handle index: index
	"char* odbx_column_name(odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	<apicall: char* 'odbx_column_name' (ulong short) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:38'!
apiQueryColumnType: handle index: index
	"char* odbx_column_type( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	<apicall: short 'odbx_column_type' (ulong short) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:42'!
apiQueryColumns: handle
	"int odbx_column_count(odbx_result_t* result )"
	<apicall: long 'odbx_column_count' (ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:42'!
apiQueryFetchRow: handle 
	"int odbx_row_fetch( odbx_result_t* result )"
	<apicall: long 'odbx_row_fetch' (ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:43'!
apiQueryFieldValue: handle index: index
	"const char* odbx_field_value( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	<apicall: char* 'odbx_field_value' (ulong ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:43'!
apiQueryFinalize: handle
	"int odbx_result_finish( odbx_result_t* result )"
	<apicall: long 'odbx_result_finish' (ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 9/25/2008 20:51'!
apiQueryResult: connectionHandle handle: handle timeout: timeout chunk: chunk
	"int odbx_result( odbx_t* handle, odbx_result_t** result, struct timeval* timeout, unsigned long chunk )"
	<apicall: long 'odbx_result' (ulong ulong* DBXTimeSpec* long) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:43'!
apiQueryRowsAffected: handle
	"uint64_t odbx_rows_affected(odbx_result_t* result )"
	<apicall: long 'odbx_rows_affected' (ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/18/2008 17:42'!
apiSetOption: handle option: anOption value: aValue
	"int odbx_set_option(odbx_t* handle, unsigned int option, void* value ) "
	<apicall: long 'odbx_set_option' (ulong ulong char*) module: 'libopendbx-1.dll' >
	^self externalCallFailed
	
! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:44'!
apiUnbind: handle 
	"int odbx_unbind(odbx_t*)"
	<apicall: long 'odbx_unbind' (ulong) module: 'libopendbx-1.dll' >
	^self externalCallFailed! !

!True methodsFor: '*OpenDBX-Core' stamp: 'EL 8/14/2008 09:18'!
asDbxString
	^'true'! !

!UndefinedObject methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 12:49'!
asDbxString
	^'NULL'! !

!Date class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:36'!
fromDbxString: aString 
	^ self readDbxFrom: aString readStream! !

!Date class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:09'!
readDbxFrom: aStream
	| year month day |

	year := (aStream upTo: $-) asInteger.
	month := (aStream upTo: $-) asInteger.
	day := (aStream upToEnd) asInteger.

	^self year: year 
		month: month 
		day: day! !

!Date methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:27'!
asDbxString
	| stream |
	stream := String new writeStream.
	self printDbxOn: stream.
	^ stream contents asDbxString ! !

!Date methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:27'!
printDbxOn: aStream
	aStream
		nextPutAll: self year asString;
		nextPut: $-;
		nextPutAll: (self monthIndex asString padded: #left to: 2 with: $0);
		nextPut: $-;
		nextPutAll: (self dayOfMonth asString padded: #left to: 2 with: $0).! !

!Number class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:10'!
fromDbxString: aString
	^self readFrom: aString readStream! !

!Boolean class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:55'!
fromDbxString: aString
	aString = '1' ifTrue: [ ^true ].
	aString = '0' ifTrue: [ ^false ].
	DBXError signal: 'Invalid boolean input: ', aString! !

Error subclass: #DBXError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXError class methodsFor: 'private' stamp: 'HMC 10/14/2008 23:50'!
header
	self subclassRisponsability! !

!DBXError class methodsFor: 'exceptionInstantiator' stamp: 'HMC 10/14/2008 23:40'!
signal: signalerText 
	super signal: self header , signalerText! !

DBXError subclass: #OpenDBXError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

OpenDBXError subclass: #DBXFatalError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXFatalError class methodsFor: 'private' stamp: 'HMC 10/14/2008 23:52'!
header
	^'FATAL OpenDBX: '! !

OpenDBXError subclass: #DBXRecoverableError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXRecoverableError class methodsFor: 'private' stamp: 'HMC 10/14/2008 23:53'!
header
	^ 'RECOVERABLE OpenDBX: '! !

DBXError subclass: #SqueakDBXError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!SqueakDBXError class methodsFor: 'private' stamp: 'HMC 10/14/2008 23:53'!
header
	^ 'SqueakDBX: '! !
DBXTimeSpec initialize!
DBXConnection initialize!
